local function usage()
  local message = "Argumentos fornecidos:\n"
  for i, a in ipairs(arg) do
    message = message .. i .. ": " .. a .. "\n"
  end
  message = message .. "Argumentos esperados:\n"
  message = message .. "<case> := MAJUSCULE / MINUSCULE\n"
  message = message .. "<input> := o caminho para o arquivo de entrada.\n"
  message = message .. "<output> := o caminho para o arquivo de sada.\n"
  error(message)
end

if #arg < 3 then
  usage()
end

local case = string.upper(arg[1])
local convert
if case == "MAJUSCULE" then
  convert = string.upper
elseif case == "MINUSCULE" then
  convert = string.lower
else
  usage()
end

local inputFile = arg[2]
local outputFile = arg[3]

print("Parmetros")
print("Case: ", case)
print("Entrada: ", inputFile)
print("Sada: ", outputFile)

local outputFile = assert(io.open(outputFile, "w+"))

for line in io.lines(inputFile) do
  line = convert(line)
  outputFile:write(line .. "\n")
end

outputFile:close()
outputFile = nil

print("Comando terminado com sucesso.")
