-- $Id: par_demo.lua 35718 2005-07-07 12:11:21Z brunoos $

dofile('../../../../../../lua/algorithms/shellExtension.lua')

local algo, version, platform = getAlgorithmInfo(arg[0])
local complementPath = getAlgorithmPath(algo, version, platform)

local PARDEMO_DIR = ALGORITHMS_DIR_LINUX..complementPath
local PREFIX=""
local SUFFIX=".[Dd][Aa][Tt]"
-- diretrio temporrio (COMPUTERNAME + pid deste shell)
local WORK_DIR = getenv("HOST")..getenv("$")
local DONE=".DONE"
local LOCK=".LOCK"
local RUNFILE_NAME = "RUNFILE.PSF"
local PARDEMO = PARDEMO_DIR.."par_demo"

-- VARIVEIS GLOBAIS

-- identificador do caso
CODE = ""

local dir
local errorMsg
dir, errorMsg = getParameterValue(arg, 'diretorio')
assert(errorMsg == nil, errorMsg)

chdir(dir)

local allFiles = listFiles(PREFIX.."*"..SUFFIX)

print("["..os.date().."] iniciando execucao...")

assert(mkdir(WORK_DIR), "impossivel criar diretorio "..WORK_DIR)

-- 
-- RECEBE: arquivo *.dat
-- RETORNA:
--    0 : no conseguiu lock OU lock criado, caso j processado
--    1 : lock criado, caso no processado
local function lockCase (file)
  local lockFile = file..LOCK
  local doneFile = file..DONE
  local result = 0
  -- Cria diretrio de lock. Se der erro, assumimos que  porque lock j
  -- foi criado por outro processo
  if mkdir(lockFile) then
    if not fileExists(doneFile) then
      --lock criado mas o caso ainda no foi processado
      result = 1
    else
      rmdir(lockFile)
    end
  end
  return result
end

function unlockCase (file)
  rmdir(file..LOCK)
end

local function getCode (file)
  return string.gsub(file, 
    regexpEscape(PREFIX).."(.*)"..regexpEscape(SUFFIX), "%1")
end

-- RECEBE: arquivo .dat
-- RETORNA:
--    0 : lock no foi criado
--    1 : lock foi criado e os arquivos foram copiados para o diretrio de
--    trabalho
local function nextCase (file)
  local result = 0
  if lockCase(file) == 1 then
    CODE = getCode(file)
    result = 1
  end
  return result
end

local function calculateCase (file)
  print("------------------------------------------------------------")
  print("Analise do caso: "..CODE)
  print("------------------------------------------------------------")
  local logfile = PREFIX..CODE.."_csgrid.log"
  local runFileHandle = fileOpen(RUNFILE_NAME, "w")
  runFileHandle:write(CODE.."P\n")
  runFileHandle:close()
  -- executa o binrio
  execCmd(SHELL_BASH, PARDEMO, logfile)
  -- sinaliza fim da execuo
  emptyFile(file..DONE)
  unlockCase(file)
end

for file in strLineIterator(allFiles) do
  local result = nextCase(file)
  if result == 1 then
    calculateCase(file)
  end
end

rmdir(WORK_DIR)
