#!/bin/env lua5

dofile('../../../../../../lua/algorithms/shellExtension.lua')

-- Altera o ttulo da janela de execuo.
setWinTitle("zip")

local input, errorMsg = getParameterValue(arg, 'ENTRADA') 
assert(errorMsg == nil, errorMsg)

local ouput 
output, errorMsg = getParameterValue(arg, 'SAIDA') 
assert(errorMsg == nil, errorMsg)

local inputTable = toStringArray(input)
local commonInPath, fileTable  = getCommonPath(inputTable)
assert(commonInPath, 
  "Nao foi possivel obter o caminho comum a todos os arquivos")

-- obtem o path da saida com relacao ao path comun
local outputRelPath = findRelativePath(commonInPath, output)
assert(outputRelPath, "Falha na obtencao do caminho relativo")

--remove o zip se ele existir e em seguida, cria um vazio
fileRemove(output)
local outFile = fileOpen(output, "w")
outFile:close()

-- Vai para o diretorio comum
chdir(commonInPath)

-- Cria arquivos temporrios (um para os arquivos e outro para os diretrios)
-- com as entradas do zip, pois podem ser passado muitos arquivos como entrada
-- e estourar o limite da linha de comando.
--local tmpFileName = mktemp()
--local tmpDirName = mktemp()
local tmpFileName = outputRelPath..".tmpfile"
local tmpDirName = outputRelPath..".tmpdir"
local tmpFileHandle, err = fileOpen(tmpFileName, "w")
local tmpDirHandle, err = fileOpen(tmpDirName, "w")
local flagFile, flagDir = false, false
for i=1, #fileTable do
  if isDir(fileTable[i]) then
    tmpDirHandle:write(fileTable[i].."\n") 
    flagDir = true
  else
    tmpFileHandle:write(fileTable[i].."\n") 
    tmpFileHandle:write(fileTable[i]..".csbase\n")
    tmpFileHandle:write(fileTable[i]..".csbase_description\n")
    flagFile = true
  end
end
tmpDirHandle:close()
tmpFileHandle:close()

setWinTitle("zip - "..output)
if flagDir then
  assert(execCmdLine(SHELL_BASH, "wzzip -rP", nil,  outputRelPath, 
    "@"..tmpDirName), "Falha na execucao do comando")
end

if flagFile then
  assert(execCmdLine(SHELL_BASH, "wzzip -P", nil,  outputRelPath, 
    "@"..tmpFileName), "Falha na execucao do comando")
end

fileRemove(tmpFileName)
fileRemove(tmpDirName)
