package csbase.algorithms.flows.actions;

import java.awt.event.ActionEvent;

import csbase.algorithms.flows.FlowApplication;
import csbase.client.applications.ApplicationImages;

/**
 * <p>
 * Ao sair da aplicao.
 * </p>
 * <p>
 *  uma ao para facilitar o uso do mtodo
 * {@link csbase.algorithms.flows.FlowApplication#closeApplication() }
 * </p>
 */
public final class ExitAction extends FlowApplicationAction {
  /**
   * Cria uma ao sair da aplicao.
   * 
   * @param application A aplicao.
   */
  public ExitAction(FlowApplication application) {
    super(application, ExitAction.class.getName() + ".name",
      ApplicationImages.ICON_EXIT_16);
  }

  /**
   * {@inheritDoc}
   */
  public void actionPerformed(ActionEvent e) {
    getApplication().closeApplication();
  }
}
