package csbase.algorithms.flows.filters;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.Transferable;

import tecgraf.javautils.vix.TypeMessage;
import csbase.algorithms.flows.Workspace;
import csbase.algorithms.flows.messages.ClipboardIsEmptyMessage;
import csbase.algorithms.flows.messages.CopyMessage;
import csbase.algorithms.flows.messages.PasteMessage;

public final class CopyAndPasteFilter extends WorkspaceFilter implements ClipboardOwner {

  private Clipboard clipboard;
  
  public CopyAndPasteFilter(Workspace workspace) {
    super(workspace);
    this.clipboard = new Clipboard(getClass().getName());
  }

  public void lostOwnership(Clipboard clipboard, Transferable contents) {
  }

  @Override
  public boolean msgHandlerVS(TypeMessage message) {
    if (message instanceof CopyMessage) {
      handleCopyMessage((CopyMessage)message);
      return true;
    }
    if (message instanceof PasteMessage) {
      handlePasteMessage((PasteMessage)message);
      return true;
    }
    if (message instanceof ClipboardIsEmptyMessage) {
      handleClipboardIsEmptyMessage((ClipboardIsEmptyMessage) message);
      return true;
    }
    return super.msgHandlerVS(message);
  }

  private void handleClipboardIsEmptyMessage(ClipboardIsEmptyMessage message) {
   message.setClipboradIsEmpty(this.clipboard.getContents(this) != null);
  }

  private void handleCopyMessage(CopyMessage message) {
    this.clipboard.setContents(message.getTransferable(), this);
  }

  private void handlePasteMessage(PasteMessage message) {
    message.setTransferable(this.clipboard.getContents(this));
  }
}
