package csbase.algorithms.flows.filters;

import csbase.algorithms.flows.Workspace;
import csbase.algorithms.flows.graph.GraphElement;
import csbase.algorithms.flows.messages.HideHintMessage;
import csbase.algorithms.flows.messages.PickElementMessage;
import csbase.algorithms.flows.messages.ShowHintMessage;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;

public final class HintElementFilter extends WorkspaceFilter {
  private GraphElement currentElement;

  public HintElementFilter(Workspace workspace) {
    super(workspace);
  }

  @Override
  public void callbackButton(Point2D pt, MouseEvent ev) {
    new HideHintMessage().sendVS(this);
    super.callbackButton(pt, ev);
  }

  @Override
  public void callbackMove(Point2D pt, MouseEvent ev) {
    if (this.currentElement != null) {
      new HideHintMessage().sendVS(this);
    }
    PickElementMessage message = new PickElementMessage(pt);
    message.sendVO(this);
    this.currentElement = message.getElement();
    if (this.currentElement != null) {
      String hint = this.currentElement.getHint(pt);
      if (hint != null) {
        new ShowHintMessage(hint).sendVS(this);
      }
    }
    super.callbackMove(pt, ev);
  }
}
