package csbase.algorithms.flows.filters;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;

import csbase.algorithms.flows.Workspace;
import csbase.algorithms.flows.graph.GraphNode;
import csbase.algorithms.flows.messages.PickNodeMessage;

/**
 * Filtro Vix para solicitar a exibio de log de um n. 
 */
public final class ShowNodeLogFileFilter extends WorkspaceFilter {
  /**
   * Cria um filtro.
   * 
   * @param workspace A rea de trabalho.
   */
  public ShowNodeLogFileFilter(Workspace workspace) {
    super(workspace);
  }

  @Override
  public void callbackButton(Point2D pt, MouseEvent ev) {
    if (
      ev.getButton() == MouseEvent.BUTTON1 &&
      ev.getID() == MouseEvent.MOUSE_CLICKED && ev.getClickCount() == 2) {
      PickNodeMessage pickNodeMessage = new PickNodeMessage(pt);
      pickNodeMessage.sendVO(this);
      GraphNode node = pickNodeMessage.getNode();
      if (node != null) {
        if (node.showLogFile()) {
          return;
        }
      }
    }
    super.callbackButton(pt, ev);
  }
}
