package csbase.algorithms.flows.filters;

import csbase.algorithms.flows.FlowApplication;
import csbase.algorithms.flows.graph.GraphElement;
import csbase.algorithms.flows.messages.PickElementMessage;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;

public final class UpdateStatusBarrFilter extends WorkspaceFilter {
  private FlowApplication application;
  private GraphElement currentElement;

  public UpdateStatusBarrFilter(FlowApplication application) {
    super(application.getWorkspace());
    setApplication(application);
  }

  @Override
  public void callbackMove(Point2D pt, MouseEvent ev) {
    if (this.currentElement != null) {
      this.application.clearStatusBarrMessage();
    }
    PickElementMessage message = new PickElementMessage(pt);
    message.sendVO(this);
    this.currentElement = message.getElement();
    if (this.currentElement != null) {
      String hint = this.currentElement.getHint(pt);
      if (hint != null) {
        this.application.setStatusBarrMessage(hint);
      }
    }
    super.callbackMove(pt, ev);
  }

  private void setApplication(FlowApplication application) {
    if (application == null) {
      throw new IllegalArgumentException("O parmetro application est nulo.");
    }
    this.application = application;
  }
}
