package csbase.algorithms.flows.graph.actions;

import java.awt.event.ActionEvent;
import java.awt.geom.Point2D;

import csbase.algorithms.flows.Workspace;
import csbase.algorithms.flows.actions.Action;
import csbase.algorithms.flows.filters.AddNodePopupActionFilter;
import csbase.algorithms.flows.filters.WorkspaceFilter;
import csbase.algorithms.flows.graph.GraphNode;
import csbase.client.applications.ApplicationImages;

/**
 * <p>Ao de menu popup que dispara a viso do configurador de algoritmos para 
 * que o usurio preencha os parmetros.</p>  
 *
 * @author lmoreira
 */
public final class AskForParameterValuesAction extends GraphElementAction {
  /**
   * Cria a ao.
   * 
   * @param node O n (No aceita {@code null}).
   */
  public AskForParameterValuesAction(GraphNode node) {
    super(node,
      AskForParameterValuesAction.class.getName()+".name",
      ApplicationImages.ICON_EDITPARAMS_16);
  }

  public void actionPerformed(ActionEvent e) {
    GraphNode node = (GraphNode) getElement();
    node.askForParameterValues();
  }
  
  /**
   * Cria o filtro que cadastra a ao no menu popup.
   * 
   * @param workspace A rea de trabalho (No aceita {@code null}).
   * 
   * @return O filtro.
   */
  public static WorkspaceFilter createFilter(Workspace workspace) {
    return new AddNodePopupActionFilter(workspace) {
                                                                                
      @Override
      protected Action createAction(GraphNode graphNode, Point2D point) {
        return new AskForParameterValuesAction(graphNode);
      }
    };
  }
}
