package csbase.algorithms.flows.graph.actions;

import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

import csbase.algorithms.flows.actions.Action;
import csbase.algorithms.flows.graph.Graph;

/**
 * Ao abstrata de menu popup para o fluxo de algoritmos.
 *
 * @author lmoreira
 */
public abstract class GraphAction extends Action {
  /**
   * O fluxo de algoritmos.
   */
  private final Graph graph;

  /**
   * Cria a ao.
   * 
   * @param graph O fluxo (No aceita {@code null}).
   * @param nameKey O nome da chave do mecanismo de internacionalizao com o 
   * nome da ao.
   * @param icon O cone da ao.
   */
  protected GraphAction(Graph graph, String nameKey, ImageIcon icon) {
    super(nameKey, icon);
    this.graph = graph;
  }

  /**
   * Cria a ao.
   * 
   * @param graph O fluxo (No aceita {@code null}).
   * @param nameKey O nome da chave do mecanismo de internacionalizao com o 
   * nome da ao.
   * @param icon O cone da ao.
   * @param acceleratorKeyStroke A tecla que dispara a ao.
   */
  protected GraphAction(
    Graph graph, String nameKey, ImageIcon icon, KeyStroke acceleratorKeyStroke) {
    super(nameKey, icon, acceleratorKeyStroke);
    this.graph = graph;
  }

  /**
   * Obtm o fluxo de algoritmos.
   * 
   * @return O fluxo de algoritmos.
   */
  protected final Graph getGraph() {
    return this.graph;
  }
}
