package csbase.algorithms.flows.messages;

import csbase.algorithms.flows.graph.GraphElement;

import tecgraf.javautils.vix.Message;

import java.awt.geom.Point2D;

public final class SelectElementMessage extends Message {
  private GraphElement element;
  private Point2D point;

  public SelectElementMessage(GraphElement element, Point2D point) {
    setElement(element);
    setPoint(point);
  }

  public GraphElement getElement() {
    return this.element;
  }

  public Point2D getPoint() {
    return this.point;
  }

  private void setElement(GraphElement element) {
    if (element == null) {
      throw new IllegalArgumentException("O parmetro element est nulo.");
    }
    this.element = element;
  }

  private void setPoint(Point2D point) {
    if (point == null) {
      throw new IllegalArgumentException("O parmetro point est nulo.");
    }
    this.point = point;
  }
}
