package csbase.algorithms.flows.zoom;

/**
 * <p>
 * Observador de mudanas no zoom.
 * </p>
 * 
 * <p>
 * Quando ocorre uma alterao do zoom em modelos de zoom
 * (<code>ZoomModel</code>),  chamado o mtodo
 * <code>wasChanged(model:ZoomModel):void</code> para informar ao observador
 * que houve a mudana.
 * </p>
 *
 * @author lmoreira
 *
 * @see ZoomModel
 */
public interface ZoomListener {
  /**
   * Houve mudana de zoom.
   *
   * @param model O modelo de zoom modificado.
   */
  void wasChanged(ZoomModel model);
}
