/*
 * $Id$
 */

package csbase.client.applications.algorithmsmanager.versiontree.actions;

import java.rmi.RemoteException;

import tecgraf.javautils.LNG;
import csbase.client.applications.algorithmsmanager.versiontree.VersionTree;
import csbase.logic.FileInfo;
import csbase.logic.algorithms.AlgorithmVersionInfo;
import csbase.remote.ClientRemoteLocator;
import csbase.remote.niotransfer.RequestTransferInfo;

/**
 * @author Tecgraf / PUC-Rio
 * 
 *         Ao que exporta um arquivo de documentao.
 */
public class ExportDocumentationFile extends AbstractExportFileAction {

  // Verso de origem do arquivo a ser exportado.
  private AlgorithmVersionInfo version;

  /**
   * Construtor.
   * 
   * @param tree rvore que detm o n fonte da ao.
   * @param version Verso de origem do arquivo a ser exportado.
   * @param file Arquivo de documentao a ser exportado.
   */
  public ExportDocumentationFile(VersionTree tree,
    AlgorithmVersionInfo version, FileInfo file) {
    super(tree, LNG.get("algomanager.menu.doc.export"), file);

    this.version = version;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected RequestTransferInfo prepareDownload(FileInfo source)
    throws RemoteException {
    return ClientRemoteLocator.algorithmService.prepareDownloadDocFile(version
      .getInfo().getId(), version.getId(), source.getPath());
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected void appletExport(FileInfo source) {
    String docDirPath = version.getDocDirPath();
    String filePath = docDirPath + "/" + source.getPath();
    String dialogTitle = LNG.get("algomanager.title.doc.management");
    export(version.getInfo().getId(), filePath, dialogTitle);
  }
}
