package csbase.client.applications.commandsmonitor.dal;

import java.util.List;

import csbase.client.applications.commandsmonitor.models.TablesTabDTO;

/**
 * Fonte de dados de informaes das abas da aplicao.
 * 
 * @author Tecgraf / PUC-Rio
 */
public interface ITablesTabDAO {

  /**
   * Obtm a configurao das abas.
   * 
   * @return configurao das abas.
   */
  List<TablesTabDTO> getTabsInfo();

  /**
   * Obtm o identificador da aba que deve estar inicialmente selecionada.
   * 
   * @return o identificador da aba que deve estar inicialmente selecionada.
   */
  String getSelectedTabId();
}
