package csbase.client.applications.fileexchanger.actions;

import javax.swing.Action;

import csbase.client.applications.fileexchanger.FileExchanger;
import csbase.client.applications.fileexchanger.actions.core.FileExchangerAction;
import csbase.client.applications.fileexchanger.logic.BlockSize;
import csbase.client.applications.fileexchanger.logic.FileExchangerConfiguration;

/**
 * Ao para definir o modo de transmisso.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class BlockSizeAction extends FileExchangerAction {

  /**
   * Modo de ajuste
   */
  final private BlockSize blockSize;

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionDone() throws Exception {
    final FileExchanger fileExchanger = getFileExchanger();
    final FileExchangerConfiguration configuration =
      fileExchanger.getConfiguration();
    configuration.setBlockSize(blockSize);
  }

  /**
   * Construtor
   * 
   * @param fileExchanger aplicao
   * @param blockSize modo a ser ajustado.
   */
  public BlockSizeAction(final FileExchanger fileExchanger, final BlockSize blockSize) {
    super(fileExchanger);
    this.blockSize = blockSize;
    final String sufix = " - " + blockSize.getSizeKb() + "kb";
    putValue(Action.NAME, blockSize.getName() + sufix);
  }
}
