package csbase.client.applications.fileexchanger.actions;

import csbase.client.applications.fileexchanger.FileExchanger;
import csbase.client.applications.fileexchanger.actions.core.FileExchangerAction;

/**
 * Ao para alternar visibilidade de colunas de detalhes de transferncia
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ToggleAdvancedColumnsVisibilityAction extends FileExchangerAction {

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionDone() throws Exception {
    final FileExchanger fileExchanger = getFileExchanger();
    final boolean isVisible = fileExchanger.isAdvancedColumnsVisible();
    fileExchanger.setAdvancedColumnsVisible(!isVisible);
  }

  /**
   * Construtor
   * 
   * @param fileExchanger aplicao
   */
  public ToggleAdvancedColumnsVisibilityAction(final FileExchanger fileExchanger) {
    super(fileExchanger);
  }
}
