package csbase.client.applications.projectsmanager.actions;

import csbase.client.applications.projectsmanager.ProjectsManager;
import csbase.client.applications.projectsmanager.actions.core.ProjectsManagerAction;
import csbase.client.applications.projectsmanager.dialogs.ProjectOccupationDialog;

/**
 * Ao que abre dilogo de ocupao de espao em disco.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class OpenProjectOccupationDialogAction extends ProjectsManagerAction {

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionDone() {
    final ProjectsManager projectsManager = getProjectsManager();
    final ProjectOccupationDialog pod =
      new ProjectOccupationDialog(projectsManager);
    pod.pack();
    pod.center();
    pod.setVisible(true);
  }

  /**
   * Construtor
   * 
   * @param projectsManager a aplicao
   */
  public OpenProjectOccupationDialogAction(final ProjectsManager projectsManager) {
    super(projectsManager);
    if (!projectsManager.isCurrentUserAdmin()) {
      setEnabled(false);
    }
  }

}
