/*
 * ClusterStarUsagePanel.java
 * $Revision: 33587 $
 */
package csbase.client.applications.sgamonitor;

import csbase.client.applications.Application;
import csbase.logic.SGAInfo;
import csbase.logic.SGASet;

/**
 * A classe <code>StarUsagePanel</code> modela o painel de monitorao que
 * exibe as cargas dos ns de um cluster como uma estrela de carga.
 *
 * @author Ana
 */
class ClusterStarUsagePanel extends StarUsagePanel {
  /** Gerenciador das informaes visualizadas */
  private ClusterCPULoadInfoHandler infoHandler = null;

  /**
   * Obtm a legenda do toggle para nomes.
   *
   * @return .
   */
  public String getNameToggleLabel() {
    return app.getString("MON_CLUSTER_STAR_NAME_TOGGLE");
  }

  /**
   * Obtm a legenda do toggle para ocupao/percentual.
   *
   * @return .
   */
  public String getPercToggleLabel() {
    return app.getString("MON_CPULOAD_STAR_PERC_TOGGLE");
  }

  /**
   * Retorna o ttulo do painel.
   *
   * @return ttulo do painel
   */
  public String getTitle() {
    return app.getString("MON_CLUSTER_STAR_TITLE");
  }

  /**
   * Atualiza as informaes dinmicas exibidas.
   *
   * @param dynamicData informaes do servidor
   */
  public void updateDynamicInfo(Object dynamicData) {
    infoHandler.updateInfo(((SGASet)dynamicData).getAllInfo());
  }

  /**
   * Constri o painel de monitorao.
   *
   * @param app .
   * @param clusterData .
   */
  public ClusterStarUsagePanel(Application app, SGAInfo[] clusterData) {
    super(app);
    infoHandler = new ClusterCPULoadInfoHandler(clusterData);
    setCanvasInfoHandler(infoHandler);
  }
}
