/*
 * DynamicInfoHandler.java
 *
 * $Author: cassino $
 * $Revision: 33587 $  - $Date: 2004-04-15 11:21:24 -0300 (Thu, 15 Apr 2004) $
 */
package csbase.client.facilities.monitoring;

/**
 * A interface <code>DynamicInfoHandler</code> modela um gerenciador genrico
 * de informaes dinmicas. Essas informaes devero ser representadas em um
 * array de  objetos, cujos elementos devem pertencer a classes que permitam a
 * obteno do "nome" do elemento correspondente e um valor corrente (double).
 *
 * @author Ana
 * @version $Revision: 33587 $
 */
public interface DynamicInfoHandler {
  public void updateInfo(Object[] dynamicInfo);

  public String getName(int i);

  public double getCurrentValue(int i);

  public boolean isValid(int i);

  public int getTotalSize();

  public int getValidSize();
}
