/*
 * $Id$
 */

package csbase.client.ias.algorithm.action;

import java.net.URL;
import java.rmi.RemoteException;

import javax.swing.JFileChooser;

import tecgraf.javautils.LNG;
import tecgraf.javautils.gui.StandardDialogs;
import csbase.client.applications.algorithmsmanager.versiontree.VersionTree;
import csbase.client.applications.algorithmsmanager.versiontree.actions.AbstractImportFileAction;
import csbase.client.desktop.Task;
import csbase.client.externalresources.ExternalResources;
import csbase.client.remote.srvproxies.AlgorithmManagementProxy;
import csbase.client.util.StandardErrorDialogs;
import csbase.logic.algorithms.AlgorithmInfo;
import csbase.remote.ClientRemoteLocator;
import csbase.remote.niotransfer.RequestTransferInfo;

/**
 * @author Tecgraf / PUC-Rio
 * 
 *         Ao de importao de uma verso zipada.
 */
@Deprecated
public class ImportVersion extends AbstractImportFileAction {

  // Algoritmo que ir receber a verso importada.
  private final AlgorithmInfo algorithm;

  /**
   * Construtor.
   * 
   * @param tree Fonte da ao.
   * @param algorithm Algoritmo que ir receber a verso importada.
   */
  public ImportVersion(VersionTree tree, AlgorithmInfo algorithm) {
    super(tree, LNG.get("algomanager.menu.version.import"),
      JFileChooser.FILES_AND_DIRECTORIES, false);

    this.algorithm = algorithm;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected Task<Boolean> createCheckFileExistenceTask(String fileName) {
    return null;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected RequestTransferInfo prepareUpload(String fileName,
    boolean isZipLocalFile) throws RemoteException {
    /*
     * O parmetro isZipLocalFile  ignorado aqui pois j  comportamento padro
     * do upload de verso descompactar qualquer arquivo zip que seja carregado
     * no servidor.
     */
    return ClientRemoteLocator.algorithmService.prepareUploadVersionPack(
      algorithm.getId(), fileName);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected void appletUpload() {
    new ImportVersionDialog().show();
  }

  /**
   * Um dilogo para importao de pacotes de verso.
   * 
   * @author lmoreira
   */
  private class ImportVersionDialog {
    /**
     * Chama o browser para upload do pacote de verso. O upload s est
     * disponivel quando os recursos externos esto habilitados.
     */
    public void show() {
      if (ExternalResources.getInstance().isEnabled()) {
        String address = AlgorithmManagementProxy.getVersionURL(algorithm
          .getId(), getWindow());
        if (address == null) {
          return;
        }
        try {
          final URL url = new URL(address);
          ExternalResources.getInstance().showDocument(url);
        }
        catch (Exception e) {
          StandardErrorDialogs.showErrorDialog(getWindow(), LNG
            .get("algomanager.title.error"), LNG
            .get("PRJ_PROJECT_FILE_UPLOAD_IO_ERROR"), e);
        }
      }
      else {
        StandardDialogs.showInfoDialog(getWindow(), LNG
          .get("algomanager.title.error"), LNG
          .get("algomanager.error.upload_not_available"));
      }
    }
  }
}
