/*
 * $Id$
 */

package csbase.client.ias.algorithm.action;

import java.awt.event.ActionEvent;
import java.text.MessageFormat;

import tecgraf.javautils.LNG;
import tecgraf.javautils.gui.StandardDialogs;
import csbase.client.applications.algorithmsmanager.dialogs.VersionDialog;
import csbase.client.ias.algorithm.AlgorithmManagementCommonTree;
import csbase.client.remote.srvproxies.AlgorithmManagementProxy;
import csbase.client.util.StandardErrorDialogs;
import csbase.logic.algorithms.AlgorithmInfo;
import csbase.logic.algorithms.AlgorithmVersionInfo;

/**
 * @author Tecgraf / PUC-Rio
 * 
 *         Ao para remover uma verso.
 */
@Deprecated
public class RemoveVersion extends AbstractAlgorithmTreeNodeAction {

  // Verso a ser removida.
  private final AlgorithmVersionInfo version;

  /**
   * Construtor.
   * 
   * @param tree rvore que detm o n fonte da ao.
   * @param version Verso a ser removida.
   */
  public RemoveVersion(AlgorithmManagementCommonTree tree,
    AlgorithmVersionInfo version) {
    super(tree, LNG.get("algomanager.menu.version.remove"));

    this.version = version;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent e) {
    new RemoveVersionDialog().show();
  }

  /**
   * Classe que representa um dilogo de remoo de verses.
   * 
   * @author Leonardo Barros
   */
  private class RemoveVersionDialog extends VersionDialog {

    /**
     * Cria o dilogo.
     */
    public RemoveVersionDialog() {
      super(version.getInfo());
    }

    /**
     * Mostra o dilogo.
     */
    public void show() {
      Object algoId = algoInfo.getId();
      dialogTitle = MessageFormat.format(LNG
        .get("algomanager.title.remove_version"), new Object[] { algoInfo
        .getName() });
      Object[] options = { LNG.get("algomanager.button.remove"),
          LNG.get("algomanager.button.cancel") };
      int opt = StandardDialogs.showOptionDialog(getWindow(), dialogTitle,
        MessageFormat.format(LNG.get("algomanager.msg.confirm.version_remove"),
          new Object[] { version.getId() }), options);
      if (opt != 0) {
        return;
      }
      AlgorithmInfo algo = AlgorithmManagementProxy.removeVersion(algoId,
        version.getId(), getWindow());
      if (algo == null) {
        StandardErrorDialogs.showErrorDialog(getWindow(), LNG
          .get("algomanager.title.error")
          + " - " + dialogTitle, MessageFormat.format(LNG
          .get("algomanager.error.version_remove"), new Object[] { version
          .getId() }));
      }
    }
  }
}
