/*
 * $Id$
 */
package csbase.client.login;

import java.util.Locale;

import javax.swing.SwingUtilities;

import tecgraf.javautils.LNG;

/**
 * Classe que implementa as aes especficas para o login default. Onde o
 * usurio utiliza dilogo de login.
 * 
 */
public class UserPasswordLogin implements LoginInterface {

  /**
   * Instncia do dilogo de login
   */
  private AbstractLoginUI loginUI;

  /**
   * O nome do sistema
   */
  private String systemName;

  /**
   * Cria instncia para tratamento do login default
   * 
   * @param loginUI Instncia do dilogo de login
   */
  public UserPasswordLogin(AbstractLoginUI loginUI) {
    this.loginUI = loginUI;
  }

  /**
   * {@inheritDoc}
   */
  public InitialContext login(Locale defaultLocale, String systemName) {
    this.systemName = systemName;
    return loginUI.execute(defaultLocale);
  }

  /**
   * {@inheritDoc}
   */
  public void notifyInitialized() {
    loginUI.getFrame().dispose();
  }

  /**
   * {@inheritDoc}
   */
  public void notifyPreInitialization() {
    try {
      SwingUtilities.invokeAndWait(new Runnable() {
        public void run() {
          loginUI.showProgress();
        }
      });
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  /**
   * {@inheritDoc}
   */
  public void notifyException(Exception e) {
    loginUI.adjustDialogStatus(true);
  }
}
