/*
 * ProjectTreeAdapter.java
 * $Author: rodrigoh $
 * $Revision: 35176 $  - $Date: 2005-02-22 12:45:47 -0300 (Tue, 22 Feb 2005) $
 */
package csbase.client.project;

import csbase.logic.CommonClientProject;
import csbase.logic.ProjectFile;

/**
 * A classe <code>ProjectTreeAdapter</code> implementa um listener da rvore de
 * projetos que oferece uma implementao vazia para todos os seus mtodos.
 */
public class ProjectTreeAdapter implements ProjectTreeListener {
  /**
   *  chamado sempre as informaes do projeto
   */
  public void projectInfoModified() {}

  /**
   *  chamado sempre que a rvore exibe um novo projeto.
   *
   * @param project .
   */
  public void projectChanged(CommonClientProject project) {}

  /**
   *  chamado sempre que um projeto eh fechado
   */
  public void projectClosed() {}

  /**
   *  chamado sempre que um projeto eh removido.
   */
  public void projectRemoved() {}

  /**
   *  chamado sempre que o menu de popup de diretrio for exbido.
   *
   * @param dir .
   */
  public void popupDirTriggered(ProjectFile dir) {}

  /**
   *  chamado sempre que o menu de popup de arquivo for exbido.
   *
   * @param dir .
   */
  public void popupFileTriggered(ProjectFile dir) {}

  /**
   *  chamado sempre que o menu de popup de seleo mltipla for exbido.
   */
  public void popupMultSelectionTriggered() {}

  /**
   *  chamado sempre que o menu de popup da raiz for exibido.
   */
  public void popupRootTriggered() {}
}
