/*
 * Detalhes da ltima alterao:
 * 
 * $Author: rodrigoh $
 * $Date$
 * $Revision: 74166 $
 */
package csbase.client.project.action;

import java.awt.event.ActionEvent;

import tecgraf.javautils.LNG;
import csbase.client.desktop.DesktopFrame;
import csbase.client.project.ProjectFileContainer;
import csbase.client.project.dialogs.UpdateFileDialog;
import csbase.logic.ClientProjectFile;

/**
 * Representa a ao que executa o dilogo de atualizao de um arquivo.
 * 
 * @author Tecgraf/PUC-Rio
 */
public final class CommonFileUpdateAction extends CommonProjectAction {
  /**
   * Prefixo das chaves de traduo.
   */
  private static final String LNG_PREFIX = "CommonFileUpdateAction.";

  /**
   * Cria a ao de execuo do dilogo de atualizao de um arquivo.
   * 
   * @param container O container onde a ao foi executada.
   */
  public CommonFileUpdateAction(ProjectFileContainer container) {
    super(container);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent e) {
    UpdateFileDialog dialog =
      new UpdateFileDialog(DesktopFrame.getInstance().getDesktopFrame(),
        (ClientProjectFile) this.getSelectedFile());
    dialog.setVisible(true);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public String getName() {
    return LNG.get(LNG_PREFIX + "name");
  }
}
