/*
 * Created on Jun 28, 2004
 */
package csbase.client.project.action;

import java.awt.Window;
import java.awt.event.ActionEvent;

import tecgraf.javautils.LNG;
import csbase.client.project.ProjectFileContainer;
import csbase.client.project.PublicationDialog;
import csbase.logic.ProjectFile;

/**
 * Ao que abre dilogo para "gerncia de publicao" de vrios arquivos
 * selecionados da rvore de projetos.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class CommonMultiSelectionFilePublishAction extends CommonProjectAction {
  /**
   * DOCUMENT ME!
   * 
   * @param container
   */
  public CommonMultiSelectionFilePublishAction(ProjectFileContainer container) {
    super(container);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent e) {
    ProjectFile[] files = getSelectedFiles();
    Window ownerWindow = getWindow();
    if (files[0].isPublishedFile()) {
      PublicationDialog.showToUnPublish(ownerWindow, files);
    }
    else {
      PublicationDialog.showToPublish(ownerWindow, files);
    }
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public String getName() {
    return LNG.get("PRJ_MANAGE_PUBLICATION");
  }
}
