/*
 * $Id: ProjectHistoryShowAction.java 82722 2008-09-11 18:24:58Z clinio $
 */
package csbase.client.project.action;

import csbase.client.desktop.RemoteTask;
import csbase.client.facilities.textviewer.TextViewer;
import csbase.client.project.ProjectTree;
import csbase.client.project.action.ProjectAction;
import csbase.logic.CommonClientProject;
import csbase.logic.ProjectFile;

import java.awt.Window;
import java.awt.event.ActionEvent;

import tecgraf.javautils.LNG;

/**
 * Ao que exibe o histrico de um projeto.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ProjectHistoryShowAction extends ProjectAction {

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent e) {
    RemoteTask<String> task = new RemoteTask<String>() {
      @Override
      public void performTask() throws Exception {
        final CommonClientProject project = getCurrentProject();
        final ProjectFile tree = project.getTree();
        final String description = tree.getDescription();
        setResult(description);
      }
    };
    final Window window = getWindow();
    final String taskTitle = getName();
    final String taskMessage = LNG.get("prjhist.msg.waiting_description");
    if (task.execute(window, taskTitle, taskMessage)) {
      final String text = task.getResult();
      final String title = LNG.get("prjhist.title");
      new TextViewer(text, title);
    }
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public String getName() {
    return LNG.get("prjhist.action");
  }

  /**
   * Construtor
   * 
   * @param treeView a rvore
   */
  public ProjectHistoryShowAction(ProjectTree treeView) {
    super(treeView);
  }
}
