/*
 * NumericTextField.java
 *
 * $Author: cassino $
 * $Revision: 33587 $  - $Date: 2004-04-15 11:21:24 -0300 (Thu, 15 Apr 2004) $
 */
package csbase.client.util;

import javax.swing.*;
import javax.swing.text.*;

/**
 * Representa um campo de entrada de texto que somente aceita caracteres
 * numricos (no decimal).
 */
public class NumericTextField extends JTextField {
  /**
   * Cria um modelo que aceita apenas caracteres nmericos.
   *
   * @return .
   */
  protected Document createDefaultModel() {
    return new NumericDocument();
  }

  /**
   * Modelo para entrada de valor numrico.
   */
  static class NumericDocument extends PlainDocument {
    public void insertString(int offs, String str, AttributeSet a)
      throws BadLocationException {
      if (str == null) {
        return;
      }
      if (str.matches("[0-9]+")) {
        super.insertString(offs, str, a);
      }
    }
  }

  /**
   * Construtor.
   *
   * @param cols .
   */
  public NumericTextField(int cols) {
    super(cols);
  }
}
