/*
 * $Id: SGAContainerSelection.java 104691 2010-04-26 21:43:07Z costa $
 */
package csbase.client.util.sga;

import tecgraf.javautils.LNG;
import tecgraf.javautils.gui.selector.ContainerSelection;
import tecgraf.javautils.gui.table.DefaultObjectTableProvider;
import tecgraf.javautils.gui.table.ObjectTableProvider;

/**
 * A classe <code>SGAContainerSelection</code> modela um componente
 * ContainerSelection que apresenta duas listas de sgas. Este componente deve
 * ser usado em qualquer dilogo que se deseje gerenciar sgas.
 */
final class SGAContainerSelection extends ContainerSelection<String> {
  /**
   * Cria uma conteiner de seleo de SGAs, vazio e habilitado.
   */
  public SGAContainerSelection() {
    super(getFormatForAvailableItems(), getFormatForSelectedItems());
  }

  /**
   * Devolve o formatador dos elementos disponveis para seleo.
   * 
   * @return .
   */
  private static ObjectTableProvider getFormatForAvailableItems() {
    return new DefaultObjectTableProvider() {
      /**
       * {@inheritDoc}
       */
      @Override
      public Object[] getCellValues(Object item) {
        return new String[] { (String) item };
      }

      /**
       * {@inheritDoc}
       */
      public String[] getColumnNames() {
        return new String[] { LNG.get("MON_GROUP_SELECTABLE_SERVERS") };
      }

      /**
       * {@inheritDoc}
       */
      public Class<?>[] getColumnClasses() {
        return new Class<?>[] { String.class };
      }
    };
  }

  /**
   * Devolve o formatador dos elementos escolhidos.
   * 
   * @return .
   */
  private static ObjectTableProvider getFormatForSelectedItems() {
    return new DefaultObjectTableProvider() {
      /**
       * {@inheritDoc}
       */
      @Override
      public Object[] getCellValues(Object item) {
        return new String[] { (String) item };
      }

      /**
       * {@inheritDoc}
       */
      public String[] getColumnNames() {
        return new String[] { LNG.get("MON_GROUP_SELECTED_SERVERS") };
      }

      /**
       * {@inheritDoc}
       */
      public Class<?>[] getColumnClasses() {
        return new Class<?>[] { String.class };
      }
    };
  }
}
