# $Id: csbase.mak 106556 2010-06-07 14:39:50Z rodrigoh $
#
# Este arquivo define variveis do makefile correspondentes s libs
# disponibilizadas pelo CSBase para os outros projetos, para facilitar
# (e centralizar) as referncias a estas. Upgrades de verses de
# bibliotecas sero atualizados aqui, e todos os makefiles que fizerem
# uso deste arquivo automaticamente utilizaro as novas verses.
# 
# O nico pr-requisito  que a varivel de ambiente CSBASE_DIR seja
# definida para apontar para o diretrio-raiz do CSBase. Como este local
# varia de projeto para projeto, esta definio deve ser feita nos
# makefiles dos projetos.
#
# O uso tpico deste arquivo :
# ...
# CSBASE_DIR := [path para o CSBase]
# include $(CSBASE_DIR)/conf/csbase.mak
# ...

# a varivel CSBASE_LIBS deve ter sido previamente definida
export CSBASE_LIBS := $(CSBASE_DIR)/libs

# definies das variveis para cada JAR

# Acme
JAR_ACME := $(CSBASE_LIBS)/acme/Acme.jar
JAR_ACME_WIN := $(subst /,\\,$(JAR_ACME))

# Ant
JAR_ANT := $(CSBASE_LIBS)/ant/ant-launcher.jar
JAR_ANT_WIN := $(subst /,\\,$(JAR_ANT))

# args4j
JAR_ARGS4J := $(CSBASE_LIBS)/args4j/args4j-2.0.12.jar
JAR_ARGS4J_WIN := $(subst /,\\,$(JAR_ARGS4J))

# Cos
JAR_COS := $(CSBASE_LIBS)/cos/cos.jar
JAR_COS_WIN := $(subst /,\\,$(JAR_COS))

# Jacorb + dependncias
export JACORB_DIR := $(CSBASE_LIBS)/jacorb

JAR_JACORB := $(JACORB_DIR)/antlr-2.7.2.jar:$(JACORB_DIR)/avalon-framework-4.1.5.jar:$(JACORB_DIR)/concurrent-1.3.2.jar:$(JACORB_DIR)/idl.jar:$(JACORB_DIR)/jacorb-2.3.0.jar:$(JACORB_DIR)/logkit-1.2.jar
JAR_JACORB_WIN := $(subst /,\\,$(JAR_JACORB))
JAR_JACORB_WIN := $(subst :,;,$(JAR_JACORB_WIN))

# Jaf
JAR_JAF := $(CSBASE_LIBS)/jaf/activation.jar
JAR_JAF_WIN := $(subst /,\\,$(JAR_JAF))

# Javamail
JAR_JAVAMAIL := $(CSBASE_LIBS)/javamail/mail.jar
JAR_JAVAMAIL_WIN := $(subst /,\\,$(JAR_JAVAMAIL))

# Javautils
JAR_JAVAUTILS := $(CSBASE_LIBS)/javautils/javautils.jar
JAR_JAVAUTILS_WIN := $(subst /,\\,$(JAR_JAVAUTILS))

# FTC
JAR_FTC := $(CSBASE_LIBS)/ftc/ftc-1.0.1.jar
JAR_FTC_WIN := $(subst /,\\,$(JAR_FTC))

# Trilead ssh2
JAR_JSCH := $(CSBASE_LIBS)/jsch/jsch-0.1.42.jar
JAR_JSCH_WIN := $(subst /,\\,$(JAR_JSCH))

# Common-net
JAR_COMMONS_NET := $(CSBASE_LIBS)/commons-net/commons-net-2.0.jar
JAR_COMMONS_NET_WIN := $(subst /,\\,$(JAR_COMMONS_NET))

# Java WebStart
JAR_JAVAWEBSTART := $(CSBASE_LIBS)/javawebstart/javaws.jar
JAR_JAVAWEBSTART_WIN := $(subst /,\\,$(JAR_JAVAWEBSTART))

# JFreechart + dependncias
JAR_JFREECHART := $(CSBASE_LIBS)/jfreechart/jfreechart-1.0.11.jar:$(CSBASE_LIBS)/jfreechart/jcommon-1.0.14.jar
JAR_JFREECHART_WIN := $(subst /,\\,$(JAR_JFREECHART))
JAR_JFREECHART_WIN := $(subst :,;,$(JAR_JFREECHART_WIN))

# JUnit
JAR_JUNIT := $(CSBASE_LIBS)/junit/junit-4.6.jar
JAR_JUNIT_WIN := $(subst /,\\,$(JAR_JUNIT))

# LDAP
JAR_LDAP := $(CSBASE_LIBS)/ldap/ldap.jar
JAR_LDAP_WIN := $(subst /,\\,$(JAR_LDAP))

# Servlet
JAR_SERVLET := $(CSBASE_LIBS)/servlet/servlet.jar
JAR_SERVLET_WIN := $(subst /,\\,$(JAR_SERVLET))

# SGAIDL
JAR_SGAIDL := $(CSBASE_LIBS)/sgaidl/sgaidl.jar
JAR_SGAIDL_WIN := $(subst /,\\,$(JAR_SGAIDL))

# WIOIDL
JAR_WIOIDL := $(CSBASE_LIBS)/wioidl/wioidl.jar
JAR_WIOIDL_WIN := $(subst /,\\,$(JAR_WIOIDL))

# CSFS
JAR_CSFS := $(CSBASE_LIBS)/csfs/csfs.jar
JAR_CSFS_WIN := $(subst /,\\,$(JAR_CSFS))

# MiGLayout
JAR_MIGLAYOUT := $(CSBASE_LIBS)/miglayout/miglayout-3.7.2-swing.jar
JAR_MIGLAYOUT_WIN := $(subst /,\\,$(JAR_MIGLAYOUT))

# OpenBus
JAR_OPENBUS := $(CSBASE_LIBS)/openbus/openbus-api-1.4.5.jar:$(CSBASE_LIBS)/openbus/openbus-idl-jacorb-1.4.5.jar:$(CSBASE_LIBS)/openbus/openbus-data_service-api-1.0.1.jar:$(CSBASE_LIBS)/openbus/openbus-data_service-idl-jacorb-1.0.1.jar:$(CSBASE_LIBS)/openbus/openbus-data_service-valuetype-1.0.1.jar:$(CSBASE_LIBS)/openbus/openbus-data_service-project-idl-jacorb-1.0.1.jar:$(CSBASE_LIBS)/openbus/openbus-data_service-project-valuetype-1.0.1.jar
JAR_OPENBUS_WIN := $(subst /,\\,$(JAR_OPENBUS))

# SCS
JAR_SCS := $(CSBASE_LIBS)/scs/scs-core-1.0.1.jar:$(CSBASE_LIBS)/scs/scs-idl-jacorb-1.0.1.jar
JAR_SCS_WIN := $(subst /,\\,$(JAR_SCS))

# DRMAA (OpenDreams)
JAR_DRMAA := $(CSBASE_LIBS)/drmaa/drmaa.jar
JAR_DRMAA_WIN := $(subst /,\\,$(JAR_DRMAA))
