package csbase.exception.algorithms;

import csbase.exception.CSBaseRuntimeException;

/**
 * Exceo levantada quando as categorias disponveis no servidor no puderam
 * ser salvas no respectivo arquivo xml.
 * 
 * Nesse arquivo so persistidas as categorias e as relaes entre categorias e
 * algoritmos.
 * 
 */
public class CategoriesFileNotSavedException extends CSBaseRuntimeException {

  /**
   * Constri uma exceo que informa que o arquivo de categorias de algoritmos
   * no foi salvo.
   * 
   * @param msg mensagem de erro
   */
  public CategoriesFileNotSavedException(String msg) {
    super(msg);
  }
}
