package csbase.exception.algorithms;

import java.text.MessageFormat;
import java.util.Arrays;

import csbase.exception.CSBaseException;

public final class ExpressionFunctionNotFoundException extends CSBaseException {

  public ExpressionFunctionNotFoundException(String functionName,
                                             Class... parameterTypes) {
    super(createMessage(functionName, parameterTypes));
  }

  private static String createMessage(String functionName,
                                      Class... parameterTypes) {
    return MessageFormat.format(
      "A funo {0} no foi encontrada.\nLista de parmetros: {1}.",
      functionName, Arrays.asList(parameterTypes));
  }
}
