/*
 * AdministrationEvent.java
 *
 * $Author: cassino $
 * $Revision: 33587 $  - $Date: 2004-04-15 11:21:24 -0300 (Thu, 15 Apr 2004) $
 */
package csbase.logic;

import java.io.Serializable;

/**
 * A classe <code>AdministrationEvent</code> representa um evento ocorrido no
 * servio de administrao. Os eventos podem ser de criao, modificao ou
 * remoo de algum objeto.
 *
 * @author $Author: cassino $
 * @version $Revision: 33587 $
 */
public class AdministrationEvent implements Serializable {
  /** O evento de criao de um objeto no servio de administrao. */
  public static final int CREATE = 1;
  /** O evento de modificao de um objeto no servio de administrao. */
  public static final int MODIFY = 2;
  /** O evento de remoo de um objeto no servio de administrao. */
  public static final int DELETE = 3;
  /** Indica qual foi o evento ocorrido no servio de administrao. */
  public int type;
  /** Indica o objeto resultante do evento ocorrido. */
  public Object item;

  /**
   * Cria o objeto que representa um evento ocorrido no servio de
   * administrao.
   *
   * @param type a ao ocorrida
   * @param item o objeto resultante da ao
   */
  public AdministrationEvent(int type, Object item) {
    this.type = type;
    this.item = item;
  }
}
