/**
 * $Id$
 */
package csbase.logic;

import java.io.Serializable;

/**
 * Contm informaes sobre a localizao do OpenBus.
 * 
 * @author Tecgraf/PUC-Rio
 */
public final class BusInfo implements Serializable {
  /**
   * A mquina onde o barramento est executando.
   */
  private String host;
  /**
   * A porta onde o barramento est executando.
   */
  private int port;

  /**
   * Cria a localizao do OpenBus.
   * 
   * @param host A mquina onde o barramento est executando.
   * @param port A porta onde o barramento est executando.
   */
  public BusInfo(String host, int port) {
    this.host = host;
    this.port = port;
  }

  /**
   * Obtm a mquina onde o barramento est executando.
   * 
   * @return A mquina onde o barramento est executando.
   */
  public String getHost() {
    return this.host;
  }

  /**
   * Obtm a porta onde o barramento est executando.
   * 
   * @return A porta onde o barramento est executando.
   */
  public int getPort() {
    return this.port;
  }
}
