/*
 * CommandKilledNotificationData.java
 * 
 * $Author: isabella $ $Date: 2008-10-31 18:19:56 -0200 (Fri, 31 Oct 2008) $
 * $Revision: 85068 $
 */

package csbase.logic;

/**
 * Classe que representa os dados de mensagem de comando interrompido em um SGA.
 * Essa interrupo foi gerada pelo usurio, via "Cancelar Comando" da interface
 * de "Monitorao de Execuo de Comandos".
 */
public class CommandKilledNotificationData extends DefaultCommandFinishedNotificationData {

  /**
   * Constri o evento de trmino de comando sem dados de tempo.
   * 
   * @param commandId identificador do comando.
   * @param cmdDesc descrio do comando.
   * @param tip Dica para auxiliar a identificao do algoritmo do comando.
   * @param startTime Hora de incio
   * @param execHost Servidor de execuo.
   * @param projectId identificador do projeto
   */
  public CommandKilledNotificationData(Object commandId, String cmdDesc,
    String tip, long startTime, String execHost, Object projectId) {
    super(commandId, cmdDesc, tip, startTime, execHost, projectId);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected String getStatusString() {
    return "KILLED";
  }

}
