package csbase.logic;

/**
 * Classe que representa os dados de mensagem de fim de comando em um SGA,
 * quando o comando deveria dar informaes sobre como a execuo terminou (com
 * sucesso ou com erro), mas no foi possvel encontrar o seu cdigo de sada.
 */
public class CommandWithNoExitCodeNotificationData extends
  DefaultCommandFinishedNotificationData {

  /**
   * Construtor
   * 
   * @param commandId identificador do comando.
   * @param cmdDesc descrio do comando.
   * @param tip Dica para auxiliar a identificao do algoritmo do comando.
   * @param startTime Hora de incio
   * @param execHost Servidor de execuo.
   * @param projectId identificador do projeto
   */
  public CommandWithNoExitCodeNotificationData(Object commandId,
    String cmdDesc, String tip, long startTime, String execHost,
    Object projectId) {
    super(commandId, cmdDesc, tip, startTime, execHost, projectId);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected String getStatusString() {
    return "NO EXIT CODE";
  }

}
