/**
 * $Id: CommonProjectInfo.java 91193 2009-05-06 17:24:04Z costa $
 */

package csbase.logic;

import java.io.Serializable;
import java.util.Hashtable;

/**
 * Modela as informaes de um projeto.
 */
public class CommonProjectInfo implements Serializable {
  /**
   * Identificao do usurio dono do projeto.
   */
  public Object userId;
  /**
   * Nome do projeto.
   */
  public String name;
  /**
   * Descrio do projeto.
   */
  public String description;
  /**
   * Todos os atributos do CommonProjectInfo so armazenados nesta Hashtable.
   */
  protected Hashtable<String, Object> attributes;

  /**
   * Retorna um atributo da classe dado o seu nome.
   * 
   * @param name .
   * 
   * @return .
   */
  public Object getAttribute(String name) {
    return attributes.get(name);
  }

  /**
   * Adiciona um atributo a classe.
   * 
   * @param key - chave para o atributo
   * @param attribute - valor para o atributo. Se for null, a chave e seu valor
   *        correspondente sero removidos, caso existam
   */
  public void setAttribute(String key, Object attribute) {
    if (attribute == null) {
      attributes.remove(key);
    }
    else {
      attributes.put(key, attribute);
    }
  }

  /**
   * @return tabela com os atributos do projeto
   */
  public Hashtable<String, Object> getAttributes() {
    return attributes;
  }

  /**
   * Redefine a tabela com os atributos do projeto.
   * 
   * @param attributes - nova tabela com atributos
   */
  public void setAttributes(Hashtable<String, Object> attributes) {
    this.attributes = attributes;
  }

  /**
   * Construtor.
   */
  public CommonProjectInfo() {
    attributes = new Hashtable<String, Object>();
  }
}
