package csbase.logic;


/**
 * Representa o evento de atualizao de um diretrio na rvore de projetos,
 * sincronizando-o com o seu equivalente no servidor.
 * 
 * @author lbarros
 */
public class DirRefreshedEvent extends ProjectEvent {
  /** Caminho para o diretrio sendo atualizado. */
  private String[] path;
  /** Referncia para o diretrio sendo atualizado. */
  private ProjectFile dir;

  /**
   * Obtm o caminho para o diretrio sendo atualizado.
   *
   * @return caminho para o diretrio sendo atualizado.
   */
  public String[] getPath() {
    return path;
  }

  /**
   * Obtm a referncia para o diretrio sendo atualizado.
   *
   * @return referncia para o diretrio sendo atualizado.
   */
  public ProjectFile getDir() {
    return dir;
  }

  /**
   * Cria o evento.
   *
   * @param path caminho para o diretrio sendo atualizado.
   * @param dir referncia para o diretrio sendo atualizado.
   */
  DirRefreshedEvent(String[] path, ProjectFile dir) {
    event = DIR_REFRESHED;
    this.path = path;
    this.dir = dir;
  }
}
