/*
 * ObserverData.java
 * 
 * $Id: ObserverData.java 90852 2009-04-27 17:43:11Z costa $
 */
package csbase.logic;

import csbase.remote.RemoteObserver;

/**
 * A classe <code>ObserverData</code> representa um observador remoto e seu
 * argumento.
 */
public class ObserverData {
  /**
   * Observador remoto.
   */
  public RemoteObserver observer;
  /**
   * Argumento do observador remoto.
   */
  public Object arg;

  /**
   * Construtor.
   * 
   * @param observer observador remoto
   * @param arg argumento do observador remoto
   */
  public ObserverData(RemoteObserver observer, Object arg) {
    this.observer = observer;
    this.arg = arg;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public boolean equals(Object obj) {
    if (!(obj instanceof ObserverData)) {
      return false;
    }
    ObserverData obsData = (ObserverData) obj;
    return (((this.observer == obsData.observer) || (this.observer
      .equals(obsData.observer))) && ((this.arg == obsData.arg) || (this.arg
      .equals(obsData.arg))));
  }

  /**
   * Cdigo hash do objeto.
   * 
   * @return inteiro representando o cdigo hash.
   */
  @Override
  public int hashCode() {
    // XXX Atributos podem ser nulos?
    String str =
      (observer == null) ? "observerNull" : Integer.toString(observer
        .hashCode());
    str += (arg == null) ? "argNull" : Integer.toString(arg.hashCode());

    return str.hashCode();
  }

}
