/*
 * $Id: OpenProjectNotificationData.java 97100 2009-10-05 19:15:19Z clinio $
 */
package csbase.logic;

/**
 * Notificao de abertura de projeto.
 * 
 * @author Tecgraf/PUC-Rio
 */
public final class OpenProjectNotificationData extends NotificationData {

  /**
   * Nome do projeto.
   */
  private final String projectName;

  /**
   * Obtm o nome do projeto.
   * 
   * @return o nome
   */
  public String getProjectName() {
    return this.projectName;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public boolean isVolatile() {
    return false;
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public String toString() {
    return "Notificao de abertura do projeto: " + projectName;
  }

  /**
   * Construtor
   * 
   * @param projectName o nome do projeto.
   */
  public OpenProjectNotificationData(final String projectName) {
    this.projectName = projectName;
  }
}
