/*
 * ProjectFileDeletedEvent.java
 *
 * $Author: taciana $
 * $Revision: 77033 $  - $Date: 2008-06-09 15:52:24 -0300 (Mon, 09 Jun 2008) $
 */
package csbase.logic;

/**
 * Representa o evento de remoo de um arquivo na rvore do projeto.
 */
public class ProjectFileDeletedEvent extends ProjectEvent {
  private String[] path;
  private int index;
  private ProjectFile removedFile;

  /**
   * Retorna o caminho do arquivo excludo como resultado do evento ocorrido.
   *
   * @return O caminho do arquivo excludo.
   */
  public String[] getPath() {
    return path;
  }
  
  /**
   * Ajuste do ndice
   * @param index o ndice
   */
  public void setRemovedFileIndex(int index) {
    this.index = index;
  }

  /**
   * Consulta ao ndice
   * @return o ndice
   */
  public int getRemovedFileIndex() {
    return index;
  }

  /**
   * @param file
   */
  public void setRemovedFile(ProjectFile file) {
    this.removedFile = file;
  }

  /**
   * @return
   */
  public ProjectFile getRemovedFile() {
    return this.removedFile;
  }
  
  /**
   * Cria uma instncia de <code>ProjectEvent</code> para o evento de remoo
   * de um arquivo na rvore de um projeto.
   *
   * @param path O caminho do arquivo excludo.
   */
  public ProjectFileDeletedEvent(String[] path) {
    event = FILE_DELETED;
    this.path = path;
  }
}
