/*
 * NotificationProjectData.java
 * 
 * $Id: ProjectNotificationData.java 65680 2007-07-23 19:43:47Z costa $
 */
package csbase.logic;

/**
 * Classe que modela uma notificao de projeto.
 */
public class ProjectNotificationData extends NotificationData {

  /** Guarda o objeto que descreve as informaes administrativas do projeto. */
  private ProjectAdminInfo info;

  /**
   * Consulta as informaes administrativas do projeto.
   * 
   * @return o objeto que contem dados de administrao do projeto
   */
  public ProjectAdminInfo getProjectAdminInfo() {
    return info;
  }

  /**
   * Definio da volatilidade da notificao.
   * 
   * @return flag indicativo.
   */
  @Override
  public boolean isVolatile() {
    return false;
  }

  /**
   * String para auditagem.
   * 
   * @return uma string
   */
  @Override
  public String toString() {
    return "PROJECT ADMIN (" + info.getProjectName() + ")";
  }

  /**
   * Constri o evento de notificao de administrao de projeto
   * 
   * @param info A informao de administrao.
   */
  public ProjectNotificationData(ProjectAdminInfo info) {
    this.info = info;
  }
}
