package csbase.logic.algorithms.parameters;

/**
 * Observador do {@link DoubleParameter Parmetro do Tipo Real}.
 * 
 * @author lmoreira
 */
public interface DoubleParameterListener {
  /**
   * Este mtodo  chamando quando ocorre mudana no valor mximo aceito ou
   * no atributo {@code includeMaximum}.
   * 
   * @param parameter O parmetro (No aceita {@code null}).
   */
  public void maximumWasChanged(DoubleParameter parameter);

  /**
   * Este mtodo  chamando quando ocorre mudana no valor mnimo aceito ou 
   * no atributo {@code includeMinimum}.
   * 
   * @param parameter O parmetro (No aceita {@code null}).
   */
  public void minimumWasChanged(DoubleParameter parameter);
}
