package csbase.logic.algorithms.parameters;

import java.io.Serializable;

/**
 * O observador de {@link EnumerationParameter parmetro do tipo enumerao}.
 */
public interface EnumerationParameterListener extends Serializable {

  /**
   * Indica o estado exibe/oculto de um item foi modificado.
   * 
   * @param parameter O parmetro afetado (No aceita {@code null}).
   * @param item O item modificado (No aceita {@code null}).
   */
  void enumerationItemWasSetVisible(EnumerationParameter parameter,
    EnumerationItem item);
}
