package csbase.logic.algorithms.parameters;

import csbase.exception.algorithms.ExpressionFunctionExecutionException;

import java.util.List;

public final class ListMinExpressionFunction extends ListExpressionFunction {
  public ListMinExpressionFunction() {
    super("list_min", new Class[] {  });
  }

  @Override
  protected Object doOperation(List<Object> values, Object... arguments)
  throws ExpressionFunctionExecutionException {
    if (values == null) {
      throw new ExpressionFunctionExecutionException("A lista est vazia.");
    }
    double minValue = Double.MAX_VALUE;
    for (Object value : values) {
      double doubleValue = Double.parseDouble(value.toString());
      if (doubleValue < minValue) {
        minValue = doubleValue;
      }
    }
    return minValue;
  }
}
