package csbase.logic.algorithms.parameters;

import java.util.List;

import csbase.exception.algorithms.ExpressionFunctionExecutionException;

public final class TableMinExpressionFunction extends TableExpressionFunction {

  public TableMinExpressionFunction() {
    super("table_min", new Class[]{});
  }

  @Override
  protected Object doOperation(List<Object> values, Object... arguments)
    throws ExpressionFunctionExecutionException {
    if (values == null) {
      throw new ExpressionFunctionExecutionException("A tabela est vazia.");
    }
    double minValue = Double.MAX_VALUE;
    for (Object value : values) {
      double doubleValue = Double.parseDouble(value.toString());
      if (doubleValue < minValue) {
        minValue = doubleValue;
      }
    }
    return minValue;
  }
}
