/*
 * $Author:$
 * $Date:$
 * $Release:$
 */
package csbase.logic.algorithms.parameters.triggers;

import csbase.logic.algorithms.parameters.SimpleParameter;
import csbase.logic.algorithms.parameters.TextParameter;
import csbase.logic.algorithms.parameters.conditions.Condition;

/**
 * Gatilho Permitir Editar Parmetro: Torna um {@link SimpleParameter parmetro} 
 * editvel quando a {@link Condition condio} associada for aceita.
 *
 * @author lmoreira
 */
public final class AllowEditParameterTrigger extends Trigger {
  /**
   * Cria o gatilho.
   * 
   * @param parameter O parmetro (No aceita {@code null}).
   * @param condition A condio (No aceita {@code null}).
   */
  public AllowEditParameterTrigger(TextParameter parameter,
    Condition condition) {
    super(parameter, condition);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public TextParameter getParameter() {
    return (TextParameter) super.getParameter();
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected void doAction() {
    getParameter().setEditable(true);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  protected void undoAction() {
    getParameter().setEditable(false);
  }
}
