/*
 * $Id: ApplicationRegistryCreationException.java 93285 2009-07-03 20:02:55Z clinio $
 */

package csbase.logic.applicationservice;

/**
 * Exceo para sinalizar falha de criao de um registry de aplicao
 * (necessariamente no servidor).
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ApplicationRegistryCreationException extends Exception {

  /**
   * Id da aplicao
   */
  final private String id;
  /**
   * Nome da propriedade mal ajustada.
   */
  final private String propertyName;

  /**
   * Consulta o Id da aplicao.
   * 
   * @return o campo id da aplicao.
   */
  final public String getId() {
    return id;
  }

  /**
   * Consulta o nome da propriedade mal ajustada.
   * 
   * @return o campo propertyName
   */
  final public String getPropertyName() {
    return propertyName;
  }

  /**
   * Construtor
   * 
   * @param id id da aplicao.
   * @param propertyName propriedade mal ajustada.
   */
  public ApplicationRegistryCreationException(String id, String propertyName) {
    this.id = id;
    this.propertyName = propertyName;
  }

}
