package csbase.logic.filters;

import csbase.logic.ProjectFile;
import csbase.logic.ProjectFileFilter;

import java.util.Iterator;

/**
 * Define um filtro composto que aceita arquivos que sejam aceitos por todos os
 * filtros da composio.
 *
 * @author Rodrigo Carneiro Henrique (rodrigoh)
 */
public final class ProjectFileCompositeAndFilter
extends ProjectFileCompositeFilter {
  public boolean accept(ProjectFile file) {
    Iterator filtersIterator = this.getFiltersIterator();
    while (filtersIterator.hasNext()) {
      ProjectFileFilter projectFileFilter =
        (ProjectFileFilter)filtersIterator.next();
      if (!projectFileFilter.accept(file)) {
        return false;
      }
    }
    return true;
  }
}
