package csbase.logic.trustedserver;

/**
 * Representa um evento de adio de um servidor confivel ao repositrio de
 * servidores confiveis.
 *
 * @author Tecgraf/PUC-Rio
 */
public final class TrustedServerAddEvent extends TrustedServerEvent {
  /** O servidor que foi adicionado. */
  private TrustedServer trustedServer;

  /**
   * Cria um evento de adio de servidor.
   *
   * @param source A origem do evento (onde o evento foi gerado).
   * @param trustedServer O servidor que foi adicionado.
   */
  public TrustedServerAddEvent(Object source, TrustedServer trustedServer) {
    super(source, TrustedServerEventType.ADD);
    this.trustedServer = trustedServer;
  }

  /**
   * Obtm o servidor que foi adicionado.
   *
   * @return O servidor adicionado.
   */
  public TrustedServer getTrustedServer() {
    return this.trustedServer;
  }
}
