package csbase.logic.trustedserver;

import java.util.EventObject;

/**
 * Representa um evento gerado pelo servio de servidores confiveis.
 *
 * @author Tecgraf/PUC-Rio
 */
public abstract class TrustedServerEvent extends EventObject {
  /** O tipo do evento. */
  private TrustedServerEventType type;

  /**
   * Cria um evento de servidor confivel.
   *
   * @param source A origem do evento (onde o evento ocorreu).
   * @param type O tipo do evento.
   *
   * @throws IllegalArgumentException Caso o tipo do evento seja nulo.
   */
  TrustedServerEvent(Object source, TrustedServerEventType type) {
    super(source);
    if (type == null) {
      throw new IllegalArgumentException("O tipo do evento no pode ser nulo.");
    }
    this.type = type;
  }

  /**
   * Obtm o tipo do evento.
   *
   * @return O tipo do evento.
   */
  public final TrustedServerEventType getType() {
    return this.type;
  }
}
