/*
 * $Id: ApplicationServiceInterface.java 105117 2010-05-05 19:28:16Z clinio $
 */
package csbase.remote;

import java.rmi.RemoteException;
import java.util.Hashtable;

import csbase.logic.applicationservice.ApplicationCategory;
import csbase.logic.applicationservice.ApplicationRegistry;
import csbase.util.remote.RemoteInputStream;

/**
 * Interface do servio de gerncia de aplicaes.
 * 
 * @author Tecgraf/PUC-Rio
 */
public interface ApplicationServiceInterface extends ServiceInterface {

  /**
   * Nome do servio para o <code>ServiceManager</code>
   */
  public static final String SERVICE_NAME = "ApplicationService";

  /**
   * Consulta as aplicaes definidas pelo sistema
   * 
   * @return a hash
   * @throws RemoteException em caso de erro.
   */
  public Hashtable<String, ApplicationRegistry> getApplicationRegistries()
    throws RemoteException;

  /**
   * Consulta as listas de categorias definidas pelo sistema
   * 
   * @return a hash
   * @throws RemoteException em caso de erro
   */
  public Hashtable<String, ApplicationCategory> getApplicationCategories()
    throws RemoteException;

  /**
   * Encontra um recurso dado seu path.
   * 
   * @param appId id da aplicao.
   * @param resourcePath path do recurso desejado.
   * @return Um objeto {@ink RemoteInputStream}, ou <tt>null</tt> se o
   *         recurso no for encontrado.
   *         
   * @throws RemoteException em caso de erro.
   */
  public RemoteInputStream getApplicationResourceAsStream(String appId,
    String[] resourcePath) throws RemoteException;
}
