/*
 * $Id$
 */
package csbase.remote;

import java.rmi.RemoteException;

import csbase.logic.BusInfo;
import csbase.logic.openbus.Credential;

/**
 * Representa o servio que trata da conexo do CSBase com o OpenBus.
 * 
 * @author Tecgraf/PUC-Rio
 */
public interface OpenBusServiceInterface extends ServiceInterface {
  /**
   * O nome do servio.
   */
  String SERVICE_NAME = "OpenBusService";

  /**
   * Obtm informaes sobre a localizao do OpenBus.
   * 
   * @return A localizao do OpenBus.
   * 
   * @throws RemoteException Usada pelo mecanismo de RMI.
   */
  BusInfo getBusInfo() throws RemoteException;

  /**
   * Obtm a credencial do servidor.
   * 
   * @return A credencial do servidor.
   * 
   * @throws RemoteException Usada pelo mecanismo de RMI.
   */
  Credential getServerCredential() throws RemoteException;
}
