/*
 * $Id: BasicCentralServerMonitor.java 87915 2009-02-02 21:16:37Z clinio $
 */
package csbase.server;

import csbase.logic.ServerURI;

/**
 * A classe <code>BasicCentralServerMonitor</code>  uma implementao de
 * <code>RemoteMonitor</code> para uso por um servidor local de um sistema
 * construdo a partir do CSBASE. Este componente  configurvel para cada
 * sistema. A configurao deste componente compreende: - o nome do sistema em
 * questo - o nome do servidor monitorado - a classe que mantm as referncias
 * para os servios remotos (a especializao de
 * <code>ServerRemoteLocator</code> para o sistema)
 * 
 * @author Tecgraf/PUC-Rio
 */
public class BasicCentralServerMonitor extends LocalServerRemoteMonitor {
  /**
   * Constri o monitor conforme a configurao de um sistema especfico.
   * 
   * @param systemName nome do sistema
   * @param serverURI URI do servidor
   * @param locator classe que mantm as referncias para os objetos remotos
   */
  public BasicCentralServerMonitor(final String systemName, final ServerURI serverURI,
    final Class<?> locator) {
    super(serverURI, locator);
  }
}
