/*
 * $Id:$
 */
package csbase.server;

import java.util.logging.Level;
import java.util.logging.LogRecord;

import csbase.logic.User;

/**
 * Classe usada para passar requisies de logs entre o servidor e o handler.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ServerLogRecord extends LogRecord {

  /**
   * Usurio que originou a chamada no servidor.
   */
  private final User user;

  /**
   * Retorna o usurio que originou a chamada no servidor.
   * 
   * @return o usurio
   */
  public User getUser() {
    return user;
  }

  /**
   * Construtor.
   * 
   * @param level nvel de logging
   * @param msg mensagem a ser gravada
   */
  public ServerLogRecord(final Level level, final String msg) {
    this(level, msg, null);
  }

  /**
   * Construtor.
   * 
   * @param level nvel de logging
   * @param msg mensagem a ser gravada
   * @param user usurio que originou a chamada no servidor
   */
  public ServerLogRecord(final Level level, final String msg, final User user) {
    super(level, msg);
    this.user = user;
  }

}
