package csbase.server.services.diskusageservice;

import csbase.remote.DiskUsageServiceInterface;

import csbase.server.Service;
import csbase.exception.*;

public class DiskUsageServiceProxy extends csbase.server.ServiceProxy implements DiskUsageServiceInterface {

public DiskUsageServiceProxy(java.lang.Object param_0) throws java.rmi.RemoteException {
  super(param_0);
}

public java.util.Hashtable<java.lang.Object, java.lang.Double> getUsersList() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return DiskUsageService.getInstance().getUsersList();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}

public double getUsedSpaceForUserMb(java.lang.Object param_0) throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return DiskUsageService.getInstance().getUsedSpaceForUserMb(param_0);
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}

public double getUsedSpaceForProjectMb(java.lang.Object param_0, java.lang.String param_1) throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return DiskUsageService.getInstance().getUsedSpaceForProjectMb(param_0, param_1);
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}

public csbase.logic.diskusageservice.DiskOccupation getServerOccupation() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return DiskUsageService.getInstance().getServerOccupation();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}

public csbase.logic.diskusageservice.DiskOccupation getProjectOccupation() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return DiskUsageService.getInstance().getProjectOccupation();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}


public boolean isAlive() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return DiskUsageService.getInstance().isAlive();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}
}
