/* KillServerServiceProxy.java
 * $Author: abrantes $
 * $Revision: 36356 $ - $Date: 2005-12-21 17:03:16 -0200 (Wed, 21 Dec 2005) $
 */
package csbase.server.services.killserverservice;

import csbase.remote.KillServerServiceInterface;
import csbase.server.Service;
import csbase.server.ServiceProxy;

import java.rmi.*;

/**
 * Proxy remoto para acesso ao Servio de Matar Servidor. Garante que o usurio
 * que realizou a chamada possa ser identificado durante a execuo do mtodo
 * do servio. Para isso, ser criado um objeto deste proxy para cada usurio
 * que se conectar ao sistema.
 */
public class KillServerServiceProxy extends ServiceProxy
implements KillServerServiceInterface {
  public KillServerServiceProxy(Object key)
  throws RemoteException {
    super(key);
  }

  public void shutdown()
  throws RemoteException {
    Service.setKey(key);
    KillServerService.getInstance().shutdown();
  }

  public boolean isAlive() throws RemoteException {
    Service.setKey(this.key);
    return KillServerService.getInstance().isAlive();
  }
}
