package csbase.server.services.openbusservice;

import csbase.remote.OpenBusServiceInterface;

import csbase.server.Service;
import csbase.exception.*;

public class OpenBusServiceProxy extends csbase.server.ServiceProxy implements OpenBusServiceInterface {

public OpenBusServiceProxy(java.lang.Object param_0) throws java.rmi.RemoteException {
  super(param_0);
}

public csbase.logic.BusInfo getBusInfo() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return OpenBusService.getInstance().getBusInfo();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}

public csbase.logic.openbus.Credential getServerCredential() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return OpenBusService.getInstance().getServerCredential();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}

public boolean isAlive() throws java.rmi.RemoteException {
  try {
    Service.setKey(this.key);
    return OpenBusService.getInstance().isAlive();
  } catch (ServiceFailureException fe) {
    logException(SERVICE_NAME,fe);
    throw new ServiceFailureException(fe.getClientMessage());
  } catch (CSBaseRuntimeException re) {
    throw re;
  } catch (Throwable t) {
    logException(SERVICE_NAME,t);
    throw new BugException();
  }
}
}