/*
 * $Id$
 */
package csbase.server.services.projectservice.openbus;

import csbase.logic.ClientProjectFile;

/**
 * Representa um conjunto de informaes sobre o dado de um projeto.
 * 
 * @author Tecgraf/PUC-Rio
 */
public final class ProjectDataInfo {
  /**
   * O identificador do dono do projeto.
   */
  private Object projectOwnerId;
  /**
   * Um arquivo do projeto.
   */
  private ClientProjectFile projectFile;

  /**
   * Cria o conjunto.
   * 
   * @param projectOwnerId O identificador do dono do projeto.
   * @param projectFile Um arquivo do projeto.
   */
  public ProjectDataInfo(Object projectOwnerId, ClientProjectFile projectFile) {
    this.projectOwnerId = projectOwnerId;
    this.projectFile = projectFile;
  }

  /**
   * Obtm o identificador do dono do projeto.
   * 
   * @return O identificador do dono do projeto.
   */
  public Object getProjectOwnerId() {
    return this.projectOwnerId;
  }

  /**
   * Obtm o arquivo do projeto.
   * 
   * @return O arquivo do projeto.
   */
  public ClientProjectFile getProjectFile() {
    return this.projectFile;
  }
}
