/*
 * ORBException.java
 *
 * $Author: cassino $
 * $Revision: 33587 $  - $Date: 2004-04-15 11:21:24 -0300 (Thu, 15 Apr 2004) $
 */
package csbase.server.services.sgaservice;

/**
 * A classe <code>ORBException</code> representa uma exceo em um servidor
 * CORBA.
 */
public class ORBException extends Exception {
  /**
   * Constri uma exceo contendo a descrio do erro ocorrido,
   *
   * @param message a descrio do erro
   */
  public ORBException(String message) {
    super(message);
  }

  /**
   * Constri uma exceo contendo a causa/exceo original
   *
   * @param exception a exceo original
   */
  public ORBException(Throwable exception) {
    super(exception);
  }

  /**
   * Constri uma exceo contendo a descrio do erro e a causa/exceo
   * original
   *
   * @param message a descrio do erro
   * @param exception a exceo original
   */
  public ORBException(String message, Throwable exception) {
    super(message, exception);
  }
}
