package csbase.server.services.sgaservice;

import csbase.exception.BugException;
import csbase.exception.CSBaseRuntimeException;
import csbase.exception.ServiceFailureException;
import csbase.remote.SGAServiceInterface;
import csbase.server.Service;

public class SGAServiceProxy extends csbase.server.ServiceProxy implements
  SGAServiceInterface {

  public SGAServiceProxy(java.lang.Object param_0)
    throws java.rmi.RemoteException {
    super(param_0);
  }

  public java.util.Vector<java.lang.String> getAllSGANames()
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getAllSGANames();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public csbase.logic.SGASet getSGASet(java.lang.String param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getSGASet(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public csbase.logic.SGAInfo[] getAllInfo(java.lang.String param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getAllInfo(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public int getUpdateInterval() throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getUpdateInterval();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public int getCommandsUpdateInterval() throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getCommandsUpdateInterval();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public csbase.logic.ServerGroupInfo[] getServerGroups()
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getServerGroups();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean setServerGroups(csbase.logic.ServerGroupInfo[] param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().setServerGroups(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean updateCommandDescription(java.lang.String param_0,
    java.lang.String param_1) throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance()
        .updateCommandDescription(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean shutdownSGA(java.lang.String param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().shutdownSGA(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean restartSGA(java.lang.String param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().restartSGA(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public java.util.Collection<java.lang.String> shutdownAllSGAs()
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().shutdownAllSGAs();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public java.util.Collection<java.lang.String> restartAllSGAs()
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().restartAllSGAs();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public csbase.logic.CommandInfo getSGACommand(java.lang.String param_0,
    java.lang.String param_1) throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getSGACommand(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public java.util.Vector<csbase.logic.CommandInfo> getAllSGACommands()
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getAllSGACommands();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public java.util.Set<csbase.logic.CommandInfo> getSGACommands(
    java.lang.String param_0) throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getSGACommands(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean killCommand(java.lang.String param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().killCommand(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean killCommand(java.lang.String param_0, java.lang.String param_1)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().killCommand(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public void killCommandAnyway(java.lang.String param_0,
    java.lang.String param_1) throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      SGAService.getInstance().killCommandAnyway(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public csbase.logic.SGAInfo getInfo(java.lang.String param_0, int param_1)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().getInfo(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean isAlive() throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().isAlive();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public void addObserver(csbase.remote.RemoteObserver param_0,
    java.lang.Object param_1) throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      SGAService.getInstance().addObserver(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean deleteObserver(csbase.remote.RemoteObserver param_0,
    java.lang.Object param_1) throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().deleteObserver(param_0, param_1);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public void notifyObservers(java.lang.Object param_0)
    throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      SGAService.getInstance().notifyObservers(param_0);
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public void deleteObservers() throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      SGAService.getInstance().deleteObservers();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public boolean hasChanged() throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().hasChanged();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }

  public int countObservers() throws java.rmi.RemoteException {
    try {
      Service.setKey(this.key);
      return SGAService.getInstance().countObservers();
    }
    catch (ServiceFailureException fe) {
      logException(SERVICE_NAME, fe);
      throw new ServiceFailureException(fe.getClientMessage());
    }
    catch (CSBaseRuntimeException re) {
      throw re;
    }
    catch (Throwable t) {
      logException(SERVICE_NAME, t);
      throw new BugException();
    }
  }
}