#!/bin/ksh

# $Id$

# Verifica a existência de referências cruzadas inválidas entre pacotes,
# através da existência de "imports" inválidos (p.ex. classes do pacote
# 'logic' incluindo classes dos pacotes 'server' ou 'client')
# 
# IMPORTANTE: não faz verificação semântica. Referências embutidas no
# código (p.ex. new client.gui.SomeClass()) não serão identificadas

BASE_PACKAGE="csbase"

. test/test_functions

# ATENÇÃO: para definir os patterns abaixo, usar:
# \<  para demarcar início de palavra
# \>  para demarcar início de palavra
# \   para fazer escape de caracteres especiais (., *)
# |   para separar diferentes strings em um mesmo pattern

# imports que devem ser considerados inválidos
LOGIC_INVALID_IMPORTS="server|client"
SERVER_INVALID_IMPORTS="client"
CLIENT_INVALID_IMPORTS="server"
CLIENT_APPS_INVALID_IMPORTS="client\.applications"

# imports que NÃO devem ser considerados inválidos.
LOGIC_VALID_IMPORTS="server\.services"
CLIENT_VALID_IMPORTS="server\.services"

info "Procurando por imports invalidos (violacao de escopo do pacote)"

# execução das verificações por cada pacote
checkImports -p logic -n "$LOGIC_INVALID_IMPORTS" -y "$LOGIC_VALID_IMPORTS"
checkImports -p server -n "$SERVER_INVALID_IMPORTS"
checkImports -p client -n "$CLIENT_INVALID_IMPORTS" -y "$CLIENT_VALID_IMPORTS"
# FIXME comentado temporariamente. Avaliar se os erros reportados devem
# ser mesmo sinalizados
#checkImports -p client -D "applications|applicationmanager" \
#    -n "$CLIENT_APPS_INVALID_IMPORTS"

test -n "$problems" && abort "Problemas nos pacotes:$problems" 1
exit 0

