package csbase.client.algorithms.flows.graph.utils;

import java.awt.Dimension;
import java.awt.Point;

import csbase.algorithms.flows.graph.Graph;
import csbase.algorithms.flows.graph.GraphNode;
import csbase.client.algorithms.AlgorithmConfiguratorView;
import csbase.logic.algorithms.AlgorithmInfo;
import csbase.logic.algorithms.AlgorithmVersionId;

public class GraphNodeFactory {

  private static int lastId = 0;

  public static GraphNode createGraphNode(Graph graph, AlgorithmInfo algo,
    int version) {
    int id = ++lastId;
    graph.createGraphNode(id, algo, new AlgorithmVersionId(version, 0, 0),
      new Point(1, 1), new Dimension(10, 10), false);
    return graph.getNode(id);
  }

  public static GraphNode createGraphNode(Graph graph,
    AlgorithmConfiguratorView view) {
    int id = ++lastId;
    graph.createGraphNode(id, view, new Point(1, 1), new Dimension(10, 10),
      false);
    return graph.getNode(id);
  }

}
