/*
 * $Author:$ $Date:$ $Release:$
 */
package csbase.client.algorithms.parameters.validators;

import java.util.Locale;

import tecgraf.javautils.LNG;
import csbase.client.algorithms.parameters.validators.BooleanParameterValidator;
import csbase.client.algorithms.parameters.validators.ValidationResult;
import csbase.logic.algorithms.parameters.BooleanParameter;

import junit.framework.TestCase;

public final class BooleanParameterValidatorTest extends TestCase {
  static {
    LNG.load("csbase.client.resources.properties.language.idiom", new Locale(
      "pt", "BR"));
  }

  public void testBooleanParameterValidator() {
    BooleanParameterValidator validator = new BooleanParameterValidator();
    assertFalse(validator.isOptional());
  }

  public void testValidateValue1() {
    BooleanParameterValidator validator = new BooleanParameterValidator();
    BooleanParameter parameter = new BooleanParameter("Nome do parmetro",
      "Rtulo do Parmetro", "Descrio do Parmetro", false, "--{0} {1}",
      null, null);
    ValidationResult result = validator.validateValue(parameter, new Boolean(
      true));
    assertNotNull(result);
    assertTrue(result.isWellSucceded());
    assertNull(result.getErrorMessage());
  }

  public void testValidateValue2() {
    BooleanParameterValidator validator = new BooleanParameterValidator();
    BooleanParameter parameter = new BooleanParameter("Nome do parmetro",
      "Rtulo do Parmetro", "Descrio do Parmetro", true, "--{0} {1}", null,
      null);
    ValidationResult result = validator.validateValue(parameter, new Boolean(
      false));
    assertNotNull(result);
    assertTrue(result.isWellSucceded());
    assertNull(result.getErrorMessage());
  }

  public void testValidateValue3() {
    BooleanParameterValidator validator = new BooleanParameterValidator();
    BooleanParameter parameter = new BooleanParameter("Nome do parmetro",
      "Rtulo do Parmetro", "Descrio do Parmetro", false, "--{0} {1}",
      null, null);
    ValidationResult result = validator.validateValue(parameter, new Boolean(
      false));
    assertNotNull(result);
    assertTrue(result.isWellSucceded());
    assertNull(result.getErrorMessage());
  }

  public void testValidateValue4() {
    BooleanParameterValidator validator = new BooleanParameterValidator();
    BooleanParameter parameter = new BooleanParameter("Nome do parmetro",
      "Rtulo do Parmetro", "Descrio do Parmetro", true, "--{0} {1}", null,
      null);
    ValidationResult result = validator.validateValue(parameter, new Boolean(
      true));
    assertNotNull(result);
    assertTrue(result.isWellSucceded());
    assertNull(result.getErrorMessage());
  }

  public void testValidateValue5() {
    BooleanParameterValidator validator = new BooleanParameterValidator();
    BooleanParameter parameter = new BooleanParameter("Nome do parmetro",
      "Rtulo do Parmetro", "Descrio do Parmetro", false, "--{0} {1}",
      null, null);
    try {
      validator.validateValue(parameter, null);
      fail("Esperada IllegalArgumentException");
    } catch (IllegalArgumentException e) {
    }
  }
}
