/*
 * $Author:$ $Date:$ $Release:$
 */
package csbase.client.algorithms.parameters.validators;

import java.util.LinkedList;
import java.util.List;
import java.util.Locale;

import tecgraf.javautils.LNG;

import junit.framework.TestCase;
import csbase.client.algorithms.parameters.validators.ValidationResult;
import csbase.logic.algorithms.parameters.EnumerationItem;
import csbase.logic.algorithms.parameters.EnumerationParameter;

public final class EnumerationParameterValidatorTest extends TestCase {
  static {
    LNG.load("csbase.client.resources.properties.language.idiom", new Locale(
      "pt", "BR"));
  }
  
  public void testValidateValue() {
    EnumerationParameterValidator validator =
      new EnumerationParameterValidator(false);
    String id = "ID do item";
    String name = "Nome do item";
    String value = "Valor do item";
    EnumerationItem item = new EnumerationItem(id, name, value, null);
    String parameterName = "Nome da enumerao";
    String parameterLabel = "Rtulo da enumerao";
    String parameterDescription = "Descrio da enumerao";
    String commandLinePattern = "{0} {1}";
    List<EnumerationItem> items = new LinkedList<EnumerationItem>();
    items.add(item);
    boolean mustSortItems = true;
    EnumerationParameter parameter = new EnumerationParameter(parameterName,
      parameterLabel, parameterDescription, item, commandLinePattern, items,
      mustSortItems);
    ValidationResult result = validator.validateValue(parameter, item);
    assertNotNull(result);
    assertTrue(result.isWellSucceded());
    assertNull(result.getErrorMessage());
  }

  public void testValidateValueWithNullValue() {
    EnumerationParameterValidator validator =
      new EnumerationParameterValidator(false);
    String id = "ID do item";
    String name = "Nome da enumerao";
    String label = "Rtulo da enumerao";
    String description = "Descrio da enumerao";
    EnumerationItem item = new EnumerationItem(id, "Nome do item",
      "Valor_do_item", null);
    String commandLinePattern = "{0} {1}";
    List<EnumerationItem> items = new LinkedList<EnumerationItem>();
    items.add(item);
    boolean mustSortItems = true;
    EnumerationParameter parameter = new EnumerationParameter(name, label,
      description, item, commandLinePattern, items,
      mustSortItems);
    ValidationResult result = validator.validateValue(parameter, null);
    assertNotNull(result);
    assertFalse(result.isWellSucceded());
    assertNotNull(result.getErrorMessage());
  }
}
