/*
 * $Author:$
 * $Date:$
 * $Release:$
 */
package csbase.logic.algorithms;

import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import csbase.logic.algorithms.parameters.InputFileParameter;
import csbase.logic.algorithms.parameters.OutputFileParameter;

public final class MockAlgorithmConfigurator extends AlgorithmConfigurator {
  private static final String CMD_PATTERN = "$NOME_DO_PARAMETRO=$VALOR_DO_PARAMETRO";

  public MockAlgorithmConfigurator(AlgorithmVersionInfo algorithmVersion,
                                   String description,
                                   ExecutionType executionType,
                                   String abbreviation, boolean provideId) {
    super(algorithmVersion, description, executionType, abbreviation, provideId, CMD_PATTERN);
  }

  public MockAlgorithmConfigurator(String name, String description,
                                   ExecutionType executionType,
                                   String abbreviation, boolean provideId) {
    super(name, description, executionType, abbreviation, provideId, CMD_PATTERN);
  }

  @Override
  public Map<Object, Object> exportValues() {
    return new HashMap<Object, Object>();
  }

  @Override
  public Set<String> getBinaryDirectories(String platformId, String fileSeparator) {
    return new HashSet<String>();
  }

  @Override
  public Set<FileParameterValue> getDirectories() {
    return new HashSet<FileParameterValue>();
  }

  @Override
  public List<InputFileParameter> getInputFileParameters() {
    return new LinkedList<InputFileParameter>();
  }

  @Override
  public Set<FileParameterValue> getInputFiles() {
    return new HashSet<FileParameterValue>();
  }

  @Override
  public List<OutputFileParameter> getOutputFileParameters() {
    return new LinkedList<OutputFileParameter>();
  }

  @Override
  public Set<FileParameterValue> getOutputFiles() {
    return new HashSet<FileParameterValue>();
  }

  @Override
  public String getParameterLabel(String parameterName) {
    return null;
  }

  @Override
  public Set<String> getParameterNames() {
    return new HashSet<String>();
  }

  @Override
  public String getParameterType(String parameterName) {
    return null;
  }

  @Override
  public String getParameterValue(String parameterName) {
    return null;
  }

  @Override
  public Set<String> getPlatforms() {
    return new HashSet<String>();
  }

  @Override
  public void importValues(Map<Object, Object> values) {
  }

  @Override
  public boolean isEnabled() {
    return false;
  }

  @Override
  public boolean isSetDefaultValues() {
    return false;
  }

  @Override
  public String makeCommandLine(CommandLineContext context) {
    return null;
  }

  @Override
  public void resetValues() {
  }

  @Override
  public boolean setDefaultInputFile(FileParameterValue inputFile) {
    return false;
  }

  @Override
  public boolean setEnabled(boolean isEnabled) {
    return false;
  }

  @Override
  public void setParameterValue(String parameterName, String parameterValue) {
  }

  @Override
  public FileParameterValue getStandardOutputFile() {
    return null;
  }
  
  @Override
  public void setStandardOutputFile(FileParameterValue standardOutputFile) {
  }
  
  @Override
  protected String getCurrentParameterFileVersion() {
    return "1.0";
  }
}

