package csbase.logic.algorithms;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;

import csbase.logic.FileInfo;
import csbase.logic.algorithms.parameters.SimpleAlgorithmConfigurator;

public class SimpleAlgorithmConfiguratorFactory {

  public static SimpleAlgorithmConfigurator createConfigurator(
    AlgorithmVersionInfo version) {
    return new SimpleAlgorithmConfigurator(version, "DESCRIPTION",
      ExecutionType.SIMPLE, "ABBR", true, "teste.ksh", "ksh", null, false,
      "$NOME_DO_PARAMETRO=$VALOR_DO_PARAMETRO");
  }

  public static AlgorithmVersionInfo addVersion(AlgorithmInfo algoInfo,
    int version) {
    AlgorithmVersionId versionId = new AlgorithmVersionId(version, 0, 0);
    AlgorithmVersionInfo algorithmVersionInfo =
      new AlgorithmVersionInfo(algoInfo, versionId,
        new Hashtable<String, List<FileInfo>>(), new HashMap<String, String>());
    algoInfo.includeVersion(versionId, algorithmVersionInfo);
    return algorithmVersionInfo;
  }

  public static AlgorithmInfo createAlgorithmInfo(int id, int numVersions) {
    AlgorithmInfo algorithmInfo =
      new AlgorithmInfo("algoritmo_teste" + id, "Algoritmo Teste" + id,
        "algoritmo_teste" + id, new Hashtable<String, String>());
    for (int i = 0; i < numVersions; i++) {
      addVersion(algorithmInfo, i + 1);
    }
    return algorithmInfo;
  }
}
