package csbase.logic.algorithms.flows;

import junit.framework.TestCase;

public final class NodeParameterTest extends TestCase {

  public void testEqualsObject1() {
    String name = "Nome";
    String label1 = "Rtulo 1";
    String type1 = "Tipo 1";
    String value1 = "Valor 1";
    NodeParameter nodeParameter1 = new NodeParameter(name, label1, type1, value1);
    String label2 = "Rtulo 2";
    String type2 = "Tipo 2";
    String value2 = "Valor 2";
    NodeParameter nodeParameter2 = new NodeParameter(name, label2, type2, value2);
    assertTrue(nodeParameter1.equals(nodeParameter2));
  }

  public void testEqualsObject2() {
    String label = "Rtulo";
    String type = "Tipo";
    String value = "Valor";
    String name1 = "Nome 1";
    NodeParameter nodeParameter1 = new NodeParameter(name1, label, type, value);
    String name2 = "Nome 2";
    NodeParameter nodeParameter2 = new NodeParameter(name2, label, type, value);
    assertFalse(nodeParameter1.equals(nodeParameter2));
  }

  public void testEqualsObject3() {
    String name = "Nome";
    String label = "Rtulo";
    String type = "Tipo";
    String value = "Valor";
    NodeParameter nodeParameter = new NodeParameter(name, label, type, value);
    assertFalse(nodeParameter.equals("Objeto de outra classe"));
  }
  
  public void testEqualsObject4() {
    String name = "Nome";
    String label = "Rtulo";
    String type = "Tipo";
    String value = "Valor";
    NodeParameter nodeParameter = new NodeParameter(name, label, type, value);
    assertFalse(nodeParameter.equals(null));
  }
  
  public void testHashCode1() {
    String name = "Nome";
    String label1 = "Rtulo 1";
    String type1 = "Tipo 1";
    String value1 = "Valor 1";
    NodeParameter nodeParameter1 = new NodeParameter(name, label1, type1, value1);
    String label2 = "Rtulo 2";
    String type2 = "Tipo 2";
    String value2 = "Valor 2";
    NodeParameter nodeParameter2 = new NodeParameter(name, label2, type2, value2);
    assertEquals(nodeParameter1.hashCode(), nodeParameter2.hashCode());
  }

  public void testNodeParameter1() {
    String name = "Nome";
    String label = "Rtulo";
    String type = "Tipo";
    String value = "Valor";
    NodeParameter nodeParameter = new NodeParameter(name, label, type, value);
    assertEquals(name, nodeParameter.getName());
    assertEquals(label, nodeParameter.getLabel());
    assertEquals(type, nodeParameter.getType());
    assertEquals(value, nodeParameter.getValue());
  }

  public void testNodeParameter2() {
    String name = "Nome";
    String label = "Rtulo";
    String type = "Tipo";
    NodeParameter nodeParameter = new NodeParameter(name, label, type, null);
    assertEquals(name, nodeParameter.getName());
    assertEquals(label, nodeParameter.getLabel());
    assertEquals(type, nodeParameter.getType());
    assertNull(nodeParameter.getValue());
  }

  public void testNodeParameter3() {
    String name = "Nome";
    String type = "Tipo";
    String value = "Valor";
    try {
      new NodeParameter(name, null, type, value);
      fail(IllegalArgumentException.class.getName());
    } catch (IllegalArgumentException e) {
    }
  }
  
  public void testNodeParameter4() {
    String name = "Nome";
    String label = "Rtulo";
    String value = "Valor";
    try {
      new NodeParameter(name, label, null, value);
      fail(IllegalArgumentException.class.getName());
    } catch (IllegalArgumentException e) {
    }
  }
  
  public void testNodeParameter5() {
    String label = "Rtulo";
    String type = "Tipo";
    String value = "Valor";
    try {
      new NodeParameter(null, label, type, value);
      fail(IllegalArgumentException.class.getName());
    } catch (IllegalArgumentException e) {
    }
  }
}
