package csbase.logic.algorithms.parameters;

import junit.framework.Assert;

public final class CheckExpressionFunction extends ExpressionFunction {

  private boolean canDoOperation;
  private SimpleAlgorithmConfigurator configurator;
  private Object[] expectedParameters;
  private Object expectedResult;
  private boolean wasDoneOperation;


  public CheckExpressionFunction(String name, Class[] parameterTypes) {
    super(name, parameterTypes);
    this.canDoOperation = false;
  }

  public CheckExpressionFunction(String name, Class[] parameterTypes,
                                 SimpleAlgorithmConfigurator configurator,
                                 Object[] expectedParameters,
                                 Object expectedResult) {
    super(name, parameterTypes);
    this.configurator = configurator;
    this.expectedParameters = expectedParameters;
    this.expectedResult = expectedResult;
    this.canDoOperation = true;
  }

  public boolean wasDoneOperation() {
    return this.wasDoneOperation;
  }

  @Override
  protected Object doOperation(SimpleAlgorithmConfigurator configurator,
                               Object... parameters) {
    Assert.assertTrue(this.canDoOperation);
    Assert.assertEquals(this.configurator, configurator);
    this.wasDoneOperation = true;
    for (int i = 0; i < parameters.length; i++) {
      Assert.assertEquals(this.expectedParameters[i], parameters[i]);
    }
    return this.expectedResult;
  }
}
