package csbase.server.services.algorithmservice.niotransfer;

import java.io.IOException;
import java.security.DigestException;

import junit.framework.TestCase;
import util.TestUtils;

/**
 * Testes unitrios para a classe {@link FileServer}.
 *
 * @author Tecgraf
 */
public class FileServerTest extends TestCase {
  
  
  /** Diretrios onde se encontram os dados necessrios para este teste. */
  private String dataDir;
  /** Servidor de transferncias de arquivos. */
  private FileServer server;
  
  /**
   * Executa antes de cada teste. Obtm o diretrio de dados para esta classe de
   * testes.
   */
  @Override
  protected void setUp() {
    dataDir = TestUtils.getDataDir(this.getClass());
    server = new FileServer(null);
  }
  
  /**
   * Testa a preparao para a exportao de um arquivo inexistente.
   * 
   * @throws DigestException em caso de falha na gerao da chave
   */
  public void testPrepareDownload1() throws DigestException {
    String sourcePath = dataDir+"inexistente.bin";
    try {
      server.prepareDownload(sourcePath);
      fail("Esperada IOException");
    }
    catch (IOException e) {}
  }

  /**
   * Testa a preparao para a importao de um arquivo para um diretrio
   * inexistente no servidor.
   * 
   * @throws DigestException em caso de falha na gerao da chave
   */
  public void testPrepareUpload1() throws DigestException {
    String targetPath = "/naoexiste/destino.bin";
    try {
      server.prepareUpload(targetPath, null);
      fail("Esperada IOException");
    }
    catch (IOException e) {}
  }
}
