package csbase.util.parser.actions;

import csbase.util.parser.Session;
import csbase.util.parser.exception.AutomatonException;
import csbase.util.parser.symbols.Symbol;

/**
 * Representa uma ao a ser executada pelo autmato finito ({@link
 * csbase.util.parser.FiniteAutomaton}) ao executar uma transio ({@link
 * csbase.util.parser.Transition}).
 */
public interface TransitionAction {
  /**
   * Executa a ao.
   *
   * @param symbol O smbolo que est sendo utilizado atualmente pelo autmato.
   * @param session A sesso de execuo do autmato.
   *
   * @throws AutomatonException Caso ocorra algum erro durante a execuo da
   *         ao.
   */
  void execute(Symbol symbol, Session session)
  throws AutomatonException;
}
