package csbase.util.parser.exception;

public class MalformedInputException extends Exception {
  private int lineNumber;

  public MalformedInputException(int lineNumber, String message) {
    super(message);
    this.lineNumber = lineNumber;
  }

  public MalformedInputException(int lineNumber, Throwable cause) {
    super(cause);
    this.lineNumber = lineNumber;
  }

  public MalformedInputException(
    int lineNumber, String message, Throwable cause) {
    super(message, cause);
    this.lineNumber = lineNumber;
  }

  public int getLineNumber() {
    return this.lineNumber;
  }
}
