package csbase.util.remote;

import java.io.OutputStream;
import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Interface do {@link RMIOutputStreamImpl}.
 * 
 * @author http://www.maelstrom.org.uk/rmi/rmi.html
 */
interface RMIOutputStream extends Remote {

  /**
   * @see OutputStream#close()
   * @throws RemoteException
   */
  void close() throws RemoteException;

  /**
   * @see OutputStream#flush()
   * @throws RemoteException
   */
  void flush() throws RemoteException;

  /**
   * @see OutputStream#write(byte[], int, int)
   * @throws RemoteException
   */
  void write(byte[] b, int off, int len) throws RemoteException;

  /**
   * @see OutputStream#write(byte[])
   * @throws RemoteException
   */
  void write(byte[] b) throws RemoteException;

  /**
   * @see OutputStream#write(int)
   * @throws RemoteException
   */
  void write(int b) throws RemoteException;
}