package csbase.util.remote;

import java.io.Serializable;

/**
 * Dados lidos pelo fluxo.
 * 
 * @author http://www.maelstrom.org.uk/rmi/rmi.html
 */
class StreamData implements Serializable {
  /** Buffer contendo os dados lidos. */
  private byte[] data;
  /** Nmero de bytes lidos. */
  private int i;

  /**
   * Construtor.
   * 
   * @param data buffer contendo os dados lidos.
   * @param i Nmero de bytes lidos ou -1 caso no haja mais dados para serem
   *        lidos.
   */
  public StreamData(byte[] data, int i) {
    this.data = data;
    this.i = i;
  }

  /**
   * Obtm o buffer contendo os dados lidos. Os dados lidos esto contidos no
   * buffer entre os ndices 0 e o nmero de bytes lidos - 1.
   * 
   * @return o buffer contendo os dados lidos.
   * 
   * @see #getResult()
   */
  public byte[] getData() {
    return data;
  }

  /**
   * Obtm o nmero de bytes lidos.
   * 
   * @return o nmero de bytes lidos.
   */
  public int getResult() {
    return i;
  }
}
