/*
 * $Id: ApplicationAboutAction.java 87981 2009-02-04 16:45:06Z clinio $
 */

package csbase.client.applications;

import java.awt.Component;
import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.JOptionPane;

import runner.LNG;

/**
 * Ao genrica de exibio de about.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ApplicationAboutAction extends ApplicationAction<Application> {

  /**
   * Construtor padro.
   * 
   * @param application a aplicao
   */
  public ApplicationAboutAction(final Application application) {
    super(application);
    putValue(Action.NAME, LNG.get("ApplicationAboutAction.title"));
    putValue(Action.SMALL_ICON, ApplicationImages.ICON_ABOUT_16);
  }


  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(final ActionEvent ae) {
    final Application application = getApplication();
    final String id = application.getId();
    final String name = application.getName();
    final String text = name+"\n("+id+")";
    final Component father = application.getApplicationFrame();
    JOptionPane.showMessageDialog(father, text, id, JOptionPane.INFORMATION_MESSAGE);
  }
}
