/*
 * $Id: ApplicationAction.java 81804 2008-08-22 14:40:45Z clinio $
 */

package csbase.client.applications;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

/**
 * Ao genrica de uma aplicao com criao de textos e imagens da prpria
 * aplicao.
 * 
 * @author Tecgraf/PUC-Rio
 * @param <A> a classe da aplicao.
 */
abstract public class ApplicationAction<A extends Application> extends AbstractAction {

  /**
   * Aplicao que lanou a ao.
   */
  final private A application;

  /**
   * Consulta  aplicao.
   * 
   * @return a aplicao.
   */
  final public A getApplication() {
    return application;
  }


  /**
   * Construtor padro.
   * 
   * @param application a aplicao
   */
  public ApplicationAction(final A application) {
    super();
    this.application = application;
  }

  /**
   * Resultado da ao.
   * 
   * @param ae evento Java
   */
  abstract public void actionPerformed(final ActionEvent ae);
}
