package csbase.client.applications;

import javax.swing.JFrame;

import runner.Runner;

import csbase.client.applicationmanager.ApplicationManager;
import csbase.logic.applicationservice.ApplicationRegistry;

/**
 * Classe que representa o stub da janela da aplicao.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ApplicationFrame extends JFrame {

  /**
   * Construtor
   * 
   * @param id identificador da aplicao.
   */
  ApplicationFrame(final String id) {
    final Runner runner = Runner.getInstance();
    final ApplicationManager manager = runner.getApplicationManager();
    final ApplicationRegistry reg = manager.getApplicationRegistry(id);
    final String title = reg.getApplicationName();
    setTitle(title);
  }
}
