package csbase.client.applications;

import java.net.URL;

import javax.swing.ImageIcon;

import runner.Runner;

/**
 * Simulao da clase no CSBASE.
 * 
 * @author Tecgraf/PUC-Rio
 */
public class ApplicationImages {

  /**
   * Imagem de busca de arquivos.
   */
  public static final ImageIcon ICON_BROWSEFILE_16 = createImageIcon("BrowseFile16");

  /**
   * Imagem de fim de programa.
   */
  public static final ImageIcon ICON_EXIT_16 = createImageIcon("Exit16");

  /**
   * Imagem "sobre" para o programa
   */
  public static final ImageIcon ICON_ABOUT_16 = createImageIcon("About16");

  /**
   * Imagem "abrir arquivo" para o programa
   */
  public static final ImageIcon ICON_OPEN_16 = createImageIcon("Open16");

  /**
   * Imagem "salvar arquivo" para o programa
   */
  public static final ImageIcon ICON_SAVE_16 = createImageIcon("Save16");

  /**
   * Imagem "salvar arquivo como" para o programa
   */
  public static final ImageIcon ICON_SAVEAS_16 = createImageIcon("SaveAs16");

  /**
   * Imagem "fechar arquivo" para o programa
   */
  public static final ImageIcon ICON_CLOSE_16 = createImageIcon("Close16");

  /**
   * Diretrio das imagens padro do CSBASE.
   */
  private static final String IMAGE_DIRECTORY = "/runner/resources/applicationimages/";

  /**
   * Imagem "imprimir" para o programa
   */
  public static final ImageIcon ICON_PRINT_16 = createImageIcon("Print16");

  /**
   * Imagem "refresh" para o programa
   */
  public static final ImageIcon ICON_REFRESH_16 = createImageIcon("Refresh16");

  /**
   * Imagem "deletar" para o programa
   */
  public static final ImageIcon ICON_DELETE_16 = createImageIcon("Delete16");

  /**
   * Nada (erro)
   */
  public static final ImageIcon ICON_NONE = createImageIcon("None");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_QUESTION_16 = createImageIcon("Question16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_ERROR_16 = createImageIcon("Error16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_WARNING_16 = createImageIcon("Warning16");


  /**
   * Imagem
   */
  public static final ImageIcon ICON_COPY_16 = createImageIcon("Copy16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_CUT_16 = createImageIcon("Cut16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_PASTE_16 = createImageIcon("Paste16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_NEW_16 = createImageIcon("New16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_ADD_16 = createImageIcon("Add16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_PAUSE_16 = createImageIcon("Pause16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_PLAY_16 = createImageIcon("Play16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_EDIT_16 = createImageIcon("Edit16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_FIND_16 = createImageIcon("Find16");


  /**
   * Imagem
   */
  public static final ImageIcon ICON_ZOOMIN_16 = createImageIcon("ZoomIn16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_ZOOMOUT_16 = createImageIcon("ZoomOut16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_FIT_16 = createImageIcon("Fit16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_IMPORT_16 = createImageIcon("Import16");

  /**
   * Imagem
   */
  public static final ImageIcon ICON_EXPORT_16 = createImageIcon("Export16");
  
  /**
   * Montagem da cone do diretrio-padro.
   * 
   * @param imageIconName nome do arquivo de imagem.
   * @return uma imagem (cone)
   */
  protected static ImageIcon createImageIcon(String imageIconName) {
    final String resPath = IMAGE_DIRECTORY + imageIconName + "." + "gif";
    final URL res = ApplicationImages.class.getResource(resPath);
    if (res == null) {
      final Runner runner = Runner.getInstance();
      runner.log(false, "Unable to find image: " + resPath);
      return ICON_NONE;
    }
    return new ImageIcon(res);
  }
}
