package textviewer;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.ImageIcon;

import csbase.client.applicationmanager.ApplicationManager;
import csbase.client.applications.ApplicationAction;

/**
 * Ao de abertura do arquivo
 * 
 * @author Tecgraf/PUC-Rio
 */
class CloneAction extends ApplicationAction<TextViewer> {

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent ae) {
    final TextViewer textViewer = getApplication();
    final String id = textViewer.getId();
    final ApplicationManager manager = ApplicationManager.getInstance();
    final TextViewer newTextViewer = manager.runApplication(id);
    newTextViewer.setText(":)");
  }

  /**
   * Construtor
   * 
   * @param textViewer a aplicao.
   */
  public CloneAction(final TextViewer textViewer) {
    super(textViewer);
    putValue(Action.NAME, textViewer.getString("clone.item"));
    
    final String tag = this.getClass().getSimpleName();
    final String img = tag+".16";
    final ImageIcon icon = textViewer.buildApplicationImage(img);
    putValue(Action.SMALL_ICON, icon);
  }
}
