package textviewer;

import java.awt.event.ActionEvent;
import java.io.InputStreamReader;

import javax.swing.Action;
import javax.swing.JOptionPane;

import csbase.client.applications.ApplicationAction;
import csbase.client.applications.ApplicationFrame;
import csbase.client.applications.ApplicationImages;
import csbase.logic.ClientProjectFile;
import csbase.logic.ClientProjectFileInputStream;
import csbase.logic.CommonClientProject;

/**
 * Ao de abertura do arquivo
 * 
 * @author Tecgraf/PUC-Rio
 */
class OpenAction extends ApplicationAction<TextViewer> {

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent ae) {
    final TextViewer textViewer = getApplication();
    final CommonClientProject prj = textViewer.getApplicationProject();
    final String fileType = "TEXT";
    final String[] fileTypes = new String[] { fileType };
    final ApplicationFrame frm = textViewer.getApplicationFrame();
    final int BUFFER_SIZE = 128;

    try {
      //      final ClientProjectFile file = null;
      final ClientProjectFile file =
        textViewer.browseFileOpenFromProject(prj, fileTypes, fileType,
          frm);
      if (file == null) {
        return;
      }
      final StringBuilder stringBuffer = new StringBuilder((int) file.size());
      final ClientProjectFileInputStream in =
        new ClientProjectFileInputStream(file, BUFFER_SIZE);
      final InputStreamReader reader = new InputStreamReader(in);
      final char[] buffer = new char[BUFFER_SIZE];
      int nbytes = reader.read(buffer);
      while (nbytes > 0) {
        stringBuffer.append(buffer, 0, nbytes);
        nbytes = reader.read(buffer);
      }
      reader.close();
      textViewer.setText(stringBuffer.toString());
    }
    catch (Exception e) {
      JOptionPane.showMessageDialog(frm, e.getMessage(), "",
        JOptionPane.ERROR_MESSAGE);
    }
  }

  /**
   * Construtor
   * 
   * @param textViewer a aplicao.
   */
  public OpenAction(final TextViewer textViewer) {
    super(textViewer);
    putValue(Action.NAME, textViewer.getString("open.item"));
    putValue(Action.SMALL_ICON, ApplicationImages.ICON_OPEN_16);
  }
}
