package textviewer;

import java.awt.event.ActionEvent;
import java.io.OutputStreamWriter;

import javax.swing.Action;
import javax.swing.JOptionPane;

import csbase.client.applications.ApplicationAction;
import csbase.client.applications.ApplicationFrame;
import csbase.client.applications.ApplicationImages;
import csbase.logic.ClientProjectFile;
import csbase.logic.ClientProjectFileOutputStream;
import csbase.logic.CommonClientProject;

/**
 * Ao de abertura do arquivo
 * 
 * @author Tecgraf/PUC-Rio
 */
class SaveAsAction extends ApplicationAction<TextViewer> {

  /**
   * {@inheritDoc}
   */
  @Override
  public void actionPerformed(ActionEvent ae) {
    final TextViewer textViewer = getApplication();
    final CommonClientProject prj = textViewer.getApplicationProject();
    final String fileType = "TEXT";
    final String[] fileTypes = new String[] { fileType };
    final ApplicationFrame frm = textViewer.getApplicationFrame();

    try {
      // final ClientProjectFile file = null;
      final ClientProjectFile file =
        textViewer.browseFileSaveFromProject(prj, fileTypes, fileType, frm);
      if (file == null) {
        return;
      }

      final String content = textViewer.getText();
      final ClientProjectFileOutputStream stream =
        new ClientProjectFileOutputStream(file);
      final OutputStreamWriter writer = new OutputStreamWriter(stream);
      writer.write(content);
      writer.flush();

      final String key = "save.ok.message";
      final String msg = textViewer.getString(key);
      JOptionPane.showMessageDialog(frm, msg, "",
        JOptionPane.INFORMATION_MESSAGE);
    }
    catch (Exception e) {
      JOptionPane.showMessageDialog(frm, e.getMessage(), "",
        JOptionPane.ERROR_MESSAGE);
    }
  }

  /**
   * Construtor
   * 
   * @param textViewer a aplicao
   */
  public SaveAsAction(final TextViewer textViewer) {
    super(textViewer);
    putValue(Action.NAME, textViewer.getString("save.as.item"));
    putValue(Action.SMALL_ICON, ApplicationImages.ICON_SAVEAS_16);
  }
}
