package csfs.client;

import java.io.RandomAccessFile;

/**
 * Implementacao do RandomAccessWrapper baseada no RandomAccessFile.
 */

public class RandomAccessWrapperRegularFile implements RandomAccessWrapper {

  private RandomAccessFile raf;
  private byte[] buffer;

  public RandomAccessWrapperRegularFile(RandomAccessFile raf, byte[] buffer) {
    this.raf = raf;
    this.buffer = buffer;
  }

  public void seek(long l) throws Exception {
    raf.seek(l);
  }

  public int read(int offset, int len) throws Exception {
    return raf.read(buffer, offset, len);
  }

  public long length() throws Exception {
    return raf.length();
  }

  public byte[] getBuffer() {
    return buffer;
  }

}
