package csfs.client;

import csfs.remote.OctetSequenceHolder;
import csfs.remote.RandomAccessChannel;

/**
 * Implementacao do RandomAccessWrapper baseada no RandomAccessChannel.
 */

public class RandomAccessWrapperRemoteFile implements RandomAccessWrapper {

  private RandomAccessChannel raf;
  private OctetSequenceHolder holder;

  public RandomAccessWrapperRemoteFile(RandomAccessChannel raf,
    OctetSequenceHolder holder) {
    this.raf = raf;
    this.holder = holder;
  }

  public void seek(long l) throws Exception {
    raf.seek(l);
  }

  public int read(int offset, int len) throws Exception {
    if (offset != 0) {
      System.out.println("Ooops! Something Wrong!");
    }
    return raf.read(len, holder);
  }

  public long length() throws Exception {
    return raf.getFile().size();
  }

  public byte[] getBuffer() {
    return holder.value;
  }
}
