package csfs.datatransfer;

import java.util.Hashtable;

/**
 * Realiza um mapeamento entre os metodos conhecidos, suas portas no servidor, e
 * a classe que define o protocolo de transferencia.
 */
public class KnownTransferMethodMap {

  private Hashtable<String, String> address = new Hashtable<String, String>();

  private Hashtable<String, DataTransferMethod> methods = new Hashtable<String, DataTransferMethod>();

  public void addMethod(String name, String copyAddress,
    DataTransferMethod method) {
    address.put(name, copyAddress);
    methods.put(name, method);
  }

  public String getAddress(String name) {
    String response = address.get(name);
    if (response == null) {
      throw new RuntimeException("O metodo " + name + " eh invalido");
    }
    return response;
  }

  public DataTransferMethod getMethod(String name) {
    DataTransferMethod response = methods.get(name);
    if (response == null) {
      throw new RuntimeException("O metodo " + name + " eh invalido");
    }
    return response;
  }
}
