package csfs.datatransfer.ftp;

import java.io.File;
import java.io.IOException;

import csfs.datatransfer.DataTransferMethod;

import csfs.impl.util.RunFTPClient;
import csfs.impl.util.Util;
import csfs.remote.FileServer;
import csfs.remote.InvalidStateException;
import csfs.remote.NotFileException;
import csfs.remote.RemoteFile;
import csfs.remote.ServerException;

public class JavaFTPdMethod implements DataTransferMethod {

  public boolean copy(File localFile, RemoteFile destination, String method)
    throws NotFileException, InvalidStateException, IOException,
    ServerException {
    String nioAddress = destination.getFileServer()
      .getCopyServerAddress(method);
    int index = nioAddress.lastIndexOf(':');
    String host = nioAddress.substring(0, index);
    int port = Integer.parseInt(nioAddress.substring(index + 1));
    String targetFilename = Util.stringArrayToString(destination.getFullName());
    RunFTPClient.copy(host, port, localFile.getAbsolutePath(), targetFilename);
    return true;
  }

  public String getName() {
    return "FTP_JavaFTPd";
  }

  public String getDetailedInfo() {
    return "FTP Method (JavaFTPd)";
  }

  public long probe(FileServer target, boolean accessDisk, int dataSize)
    throws ServerException {
    throw new UnsupportedOperationException("O metodo " + getName()
      + " ainda nao suporta a operacao de probe.");
  }

}
