package csfs.datatransfer.ftp;

import java.io.File;
import java.io.IOException;

import csfs.datatransfer.DataTransferMethod;
import csfs.impl.util.RunFTPClient;
import csfs.impl.util.Util;
import csfs.remote.InvalidStateException;
import csfs.remote.NotFileException;
import csfs.remote.RemoteFile;
import csfs.remote.ServerException;

/**
 * A classe PureFTPdMethod utiliza um comando externo para realizar a copia de
 * um arquivo.
 */
public class PureFTPdMethod implements DataTransferMethod {

  /**
   * Copia o arquivo local para o arquivo de destino (remoto).
   */
  public boolean copy(File localFile, RemoteFile destination, String method)
    throws NotFileException, InvalidStateException, IOException,
    ServerException {
    System.out.println(">> copy");// #LEO#
    String remoteAddress = destination.getFileServer().getCopyServerAddress(
      method);
    System.out.println("remoteAddress: " + remoteAddress);// #LEO#
    int index = remoteAddress.lastIndexOf(':');
    String host = remoteAddress.substring(0, index);
    System.out.println("host: " + host);// #LEO#    
    int port = Integer.parseInt(remoteAddress.substring(index + 1));
    System.out.println("port: " + port);// #LEO#
    String targetFilename = Util.stringArrayToString(destination.getFullName());
    System.out.println("targetFileName: " + targetFilename);// #LEO#    
    // Realiza uma chamado de um comando externo para copiar o arquivo.
    RunFTPClient.copy(host, port, localFile.getAbsolutePath(), targetFilename);
    return true;
  }

  public String getName() {
    return "FTP_PureFTPd";
  }

  public String getDetailedInfo() {
    return "FTP Method (PureFTPd)";
  }

}
