package csfs.datatransfer.nonblockingnio;

import java.io.IOException;

/**
 * Classe abstrata que representa um estado para o gerenciador de importao (<code>ImportHandler</code>).
 * 
 * @author Leonardo Barros
 */
public abstract class ImportState {
  /** Referncia para o gerenciador de importao. */
  protected ImportHandler handler;
  /** Bytes remanescentes a serem transferidos. */
  protected long remainingBytes;

  /**
   * L o canal.
   * 
   * @throws IOException
   */
  public abstract void read() throws IOException;

  /**
   * Decrementa o contador de bytes remanescentes para leitura.
   * 
   * @param value valor a ser decrementado.
   * 
   * @throws IOException
   */
  protected abstract void decRemainingBytes(long value) throws IOException;
}
