package csfs.impl;

import java.util.Arrays;

import org.omg.CORBA.ORB;
import csfs.remote.RemoteFile;
import csfs.remote.FileServer;
import csfs.remote.FileServerHelper;
import csfs.remote.ServerException;

/**
 * A classe <class>ClientCorbaloc</class> foi desenvolvida para testes manuais
 * e no  utilizada usualmente pelo sistema.
 * 
 * @version 1.0 27 Jun 2005
 * @author Marcelo Nery dos Santos
 */
public class ClientCorbaloc {

  public static void main(String args[]) {

    try {
      ORB orb = ORB.init(args, null);
      String corbaloc1 = "corbaloc::1.2@10.0.16.6:10000/standardImplName/FileServerPOA/FileServer";
      String corbaloc2 = "corbaloc::1.2@10.0.16.6:10001/standardImplName/FileServerPOA/FileServer";
      org.omg.CORBA.Object obj1 = orb.string_to_object(corbaloc1);
      org.omg.CORBA.Object obj2 = orb.string_to_object(corbaloc2);
      FileServer fileServer1 = FileServerHelper.narrow(obj1);
      FileServer fileServer2 = FileServerHelper.narrow(obj2);
      RemoteFile root1 = fileServer1.getRoot();
      RemoteFile root2 = fileServer2.getRoot();

      // add something here!

      fileServer1.shutdown();
      fileServer2.shutdown();

    }
    catch (Exception ex) {
      System.out.println(ex.getMessage());
      ex.printStackTrace();
      if (ex instanceof ServerException) {
        System.out.println("\nmessage=" + ((ServerException) ex).message);
      }
    }

  }
}
