package csfs.impl.filetracker;

/**
 * A classe <class>FileTrackerLeasingThread</class> implementa uma thread
 * auxiliar para invocar o mtodo verifyObjectValidity na classe
 * FileTrackerLeasing.
 * 
 * @version 1.0 27 Jun 2005
 * @author Marcelo Nery dos Santos
 */
public class FileTrackerLeasingThread extends Thread {

  private FileTrackerLeasing fileTracker;
  private int sleepTime;

  public FileTrackerLeasingThread(FileTrackerLeasing fileTracker, int sleepTime) {
    this.fileTracker = fileTracker;
    this.sleepTime = sleepTime;
  }

  public void run() {
    try {
      while (true) {
        sleep(sleepTime);
        fileTracker.verifyObjectValidity();
      }
    }
    catch (InterruptedException ex) {
      ex.printStackTrace();
    }
  }
}
