package csfs.impl.util;

import java.io.*;

/**
 * Implementacao da execucao de um comando externo baseado na classe Runtime.
 */
public class ExternalCommandRunner extends Thread {

  private String[] cmd;
  private boolean finished;
  private boolean normalTermination;

  public ExternalCommandRunner(String[] cmd) {
    this.cmd = cmd;
  }

  public synchronized boolean myWaitFor() {
    while (!finished) {
      try {
        wait();
      }
      catch (Exception exc) {
        exc.printStackTrace();
      }
    }
    return normalTermination;
  }

  public synchronized void notifyEnd() {
    System.out.println("ExternalCommandRunner: END!");
    finished = true;
    notifyAll();

  }

  public void run() {
    try {

      final Process p = Runtime.getRuntime().exec(cmd, null,
        new File(SystemProperties.getProperty("ROOT_DIR")));
      System.out.println("ExternalCommandRunner: START!!!");

      new Thread(new Runnable() {
        public void run() {
          try {
            BufferedInputStream in = new BufferedInputStream(p.getInputStream());
            int c;
            while ((c = in.read()) != -1) {
              System.out.print((char) c);
            }
            in.close();
          }
          catch (Exception ex) {
            ex.printStackTrace();
          }
        }
      }).start();

      new Thread(new Runnable() {
        public void run() {
          try {
            BufferedInputStream in = new BufferedInputStream(p.getErrorStream());
            int c;
            while ((c = in.read()) != -1) {
              System.err.print((char) c);
            }
            in.close();
          }
          catch (Exception ex) {
            ex.printStackTrace();
          }
        }
      }).start();

      new Thread(new Runnable() {
        public void run() {
          try {
            while (!finished) {
              sleep(300000);
              if (!finished) {
                final Process p2 = Runtime
                  .getRuntime()
                  .exec(
                    new String[] { "sh",
                        "/home/prj/csbase/mnery/working_area/remotefilesystem/ps.sh" });
                BufferedReader in2 = new BufferedReader(new InputStreamReader(
                  p2.getInputStream()));
                String response = in2.readLine();
                response = response.trim();
                System.out.println("ps output:" + response);
                if (response.startsWith("0")) {
                  System.out.println("WHERE IS THE PROCESS???");
                  normalTermination = false;
                  notifyEnd();
                }
              }
            }
          }
          catch (Exception ex) {
            ex.printStackTrace();
          }
        }
      }).start();

      int exitValue = p.waitFor();
      normalTermination = true;
      notifyEnd();

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
}

/*
 *  // if (!response) { // //this is a patch // String osName =
 * System.getProperty("os.name" ); // String[] cmd = new String[4]; // if(
 * osName.equals( "Windows NT" ) || osName.equals( "Windows XP" ) ) { // cmd[0] =
 * "cmd.exe"; // cmd[1] = "/C"; // cmd[2] = "del"; // cmd[3] =
 * Util.systemFileSeparatorToLocalFileSeparator(systemPath); // while
 * (cmd[3].charAt(0)==File.separatorChar) { // cmd[3] = cmd[3].substring(1); // } //
 * ExternalCommandRunner runner = new ExternalCommandRunner(cmd); //
 * runner.run(); // runner.myWaitFor(); // } // } // response =
 * !localFile.exists();
 * 
 */

