package csfs.impl.util;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

import csfs.remote.*;

/**
 * Essa classe eh utilizada para encapsular uma excecao nao prevista no CSFS,
 * enviando algo que seja serializavel no mundo CORBA (evitando um erro
 * CORBA_UNKNOWN).
 */
public class ServerExceptionBuilder {

  public static ServerException createServerException(Exception exc) {
    ByteArrayOutputStream stackTrace = new ByteArrayOutputStream();
    PrintStream stackTracePrintStream = new PrintStream(stackTrace);
    exc.printStackTrace(stackTracePrintStream);
    stackTracePrintStream.close();
    String cause = stackTrace.toString();
    cause = (cause == null ? "<null>" : cause);
    cause = cause.replaceAll("[^\\p{ASCII}]", "?");
    return new ServerException("BLA", cause);
  }
}
