package jni.precisionclock;

/**
 * The native clock implementatation returns a number containning at most 9
 * digits, represententing the number of microseconds since Epoch, due to
 * precision reasons, this number in truncated at the most significant digits
 */

public class PrecisionChronometer {

  private long nativeStartTime;
  private long systemStartTime;

  static {
    System.loadLibrary("PrecisionClock");
  }

  public void reset() {
    nativeStartTime = getTime();
    systemStartTime = System.currentTimeMillis();
  }

  public long elapsedTime() {
    long nativeTime = getTime();
    long systemTime = System.currentTimeMillis();
    long response;
    long systemElapsedTime = (systemTime - systemStartTime);
    if (systemElapsedTime < 1000000) {
      response = nativeTime - nativeStartTime;
    }
    else {
      response = systemElapsedTime * 1000;
    }
    return response;
  }

  private native long getTime();

}
