import java.io.*;
import java.util.Random;

public class DataSetGenerator {

  public static void generateRegularTextFile(String name, String contents,
    int minimumSize) throws Exception {
    BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(
      name));
    byte[] contentsBytes = contents.getBytes();
    int size = contentsBytes.length;
    int written = 0;
    while (written < minimumSize) {
      out.write(contentsBytes);
      written = written + size;
    }
    out.close();
  }

  public static void generateRandomTextFile(String name, int size, long seed)
    throws Exception {
    BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(
      name));
    Random rand = new Random(seed);
    int written = 0;
    while (written < size) {
      out.write(rand.nextInt(256));
      written++;
    }
    out.close();
  }

  public static void main(String[] args) throws Exception {
    // DataSetGenerator.generateRegularTextFile("/tmp/mnery/sample","A",1024*1024*256);
    if (args == null || args.length == 0) {
      args = new String[] { "..\\remotefilesystem\\root\\random_8MB", "8" };
    }
    DataSetGenerator.generateRandomTextFile(args[0], 1024 * 1024 * Integer
      .parseInt(args[1]), Long.parseLong(args[2]));
  }

}
