import java.io.*;

public class IOTester {

  public static void main(String args[]) throws Exception {

    String filename = args[0];
    double rate = Double.parseDouble(args[1]);
    double buffer = Double.parseDouble(args[2]);

    BufferedInputStream in = new BufferedInputStream(new FileInputStream(
      args[0]), (int) (buffer * 1024));
    byte[] bufferArray = new byte[(int) (buffer * 1024)];

    double interStepPace = (1 * 1000)
      / ((rate * 1024 * 1024) / (buffer * 1024));

    System.out.println("I think I should waste: " + interStepPace
      + " miliseconds between each read");

    long filesize = in.available();

    double steps = filesize / (buffer * 1024);

    System.out.println("I will perform: " + steps + " steps.");

    long start = System.currentTimeMillis();

    System.out.println("Start Time: " + start);

    long estimatedStop = start + (int) (interStepPace * steps);

    System.out.println("Estimated Stop Time: " + estimatedStop);

    int i = (int) steps;

    int bytesRead = 0;

    while (i > 0) {
      bytesRead += in.read(bufferArray, 0, (int) (buffer * 1024));
      int sleepTime = (int) ((double) ((estimatedStop - System
        .currentTimeMillis())) / i);
      i--;
      System.out.println("I will sleep now: " + sleepTime + " miliseconds");
      if (sleepTime > 0) {
        Thread.sleep(sleepTime);
      }
    }

    long totalTime = System.currentTimeMillis() - start;

    System.out.println("Total Time = " + totalTime);
    if (totalTime > 0) {
      System.out.println("Read rate = "
        + (bytesRead / (double) (totalTime / 1000)) + "bytes/s ("
        + (((double) (bytesRead / totalTime)) / (1024)) + " MB/s)");
    }
  }

}
