/**
 *   FUSE-J: Java bindings for FUSE (Filesystem in Userspace by Miklos Szeredi (mszeredi@inf.bme.hu))
 *
 *   Copyright (C) 2003 Peter Levart (peter@select-tech.si)
 *
 *   This program can be distributed under the terms of the GNU LGPL.
 *   See the file COPYING.LIB
 */

package fuse;

import fuse.util.Struct;


public class FuseStatfs extends Struct
{
   public int blockSize;
   public int blocks;
   public int blocksFree;
   public int files;
   public int filesFree;
   public int namelen;


   protected boolean appendAttributes(StringBuffer buff, boolean isPrefixed)
   {
      buff.append(super.appendAttributes(buff, isPrefixed)? ", " : " ");

      buff.append("blockSize=").append(blockSize)
          .append(", blocks=").append(blocks)
          .append(", blocksFree=").append(blocksFree)
          .append(", files=").append(files)
          .append(", filesFree=").append(filesFree)
          .append(", namelen=").append(namelen);

      return true;
   }
}
