-- $Id: csmain.lua 35101 2005-01-28 20:16:32Z costa $

require "oo"
require "csglobal"
require "csversions"
require "global"

Main = Module:new {
    params = "vhf",
    provides = NONCMD_MODULE.MAIN,
}

function Main:check ()
    return false
end

function Main:execute (args, params)
    params = string.concat(params, self.params)
    self.getopt:parse(args, params)
    -- mostramos o help global apenas se nenhuma ao foi especificada
    -- (neste caso, ser exibido apenas o help da prpria ao)
    if self.getopt:opt("h") and self.getopt:nargs() == 0 then
        self:help()
        return
    end
    if self.getopt:opt("v") then
        cs_log:setLevel(Log.level.DEBUG)
    end

    if self.getopt:nargs() == 0 then
        cs_log:warn("nenhuma acao foi especificada. Use o parametro '-h' para ajuda")
        cs_finalize(1)
    end

    -- arg[1]  a ao a ser executada
    local act = self.getopt:arg(1)
    abort(cs_isAction(act), "operacao invalida")

    cs_requirementPolicy(self.getopt:opt("f"))
    local action = Action:new(act)
    action:execute(args, params)
end

function Main:help ()
    -- se foi especificada uma ao, o help associado a esta deve ser
    -- exibido ao invs do help global
    local action = self.getopt:arg(1)
    if action then
        if cs_isAction(action) then
            cs_getModule(action):help()
            return
        else
            cs_log:warn("acao invalida")
        end
    end

    print("\nAcoes:\n----------")
    for action, mdata in cs_moduleDataList() do
        if cs_isAction(action) then
            print(string.format("%-15s: %s", action, mdata.module.info))
        end
    end
    print([[

Parametros globais:
----------
-v          : verbose mode
-f          : forca execucao mesmo que requisitos de versoes nao sejam
              atendidos
-h          : este texto [*]

[*] o parametro -h pode ser utilizado juntamente com um comando para se
    obter ajuda apenas para o mesmo. Ex.: csmake -h build
]])

    print("Versoes dos programas ("..HOSTNAME.."):\n")
    Versions:printVersions()
    cs_finalize(0)
end

-- ==================================================
-- cadastramento do mdulo

cs_registerModule(Main)
