-- $Id: sandbox.lua 33886 2004-06-20 22:01:32Z costa $

Sandbox = OO:new()

-- sobrecarga no mtodo de new, para garantir que objetos Sandbox
-- tenham seus prprios campos _sb (e no usem o campo da classe)
function Sandbox:new (tab)
    local obj = OO.new(self, tab)
    obj._sb = {}
    return obj
end

-- funde outra sandbox  corrente
function Sandbox:merge (otherSB)
    for k,v in pairs(otherSB) do
        self._sb[k] = v
    end
end

-- adiciona par (key, val)  sandbox
function Sandbox:add (key, val)
    self._sb[key] = val
    -- se no "encaixotarmos" funes definidas externamente, a sandbox
    -- no valer para elas tambm
    if type(val) == "function" then
        setfenv(val, self._sb)
    end
end

-- carrega arquivo usando a sandbox como ambiente (mas no o executa)
function Sandbox:loadFile (fname)
    local chunk, err = loadfile(fname)
    if chunk then setfenv(chunk, self._sb) end
    return chunk, err
end

-- retorna valor associado  chave 'key'
function Sandbox:get (key)
    return self._sb[key]
end
