/**
 * TestRole_User.java  $Author: cassino $ $Revision: 33587 $ - $Date: 2004/03/17
 * 20:22:38 $
 */
package server.providers;

import csbase.logic.*;

import util.*;

import java.util.Vector;

/**
 * A classe <code>TestRole_User</code> representa um caso de teste para os
 * relacionamentos entre os Perfis e os Usurios.
 */
public class TestRole_User extends CSBaseAbstractTestCase {
  /**
   * Testa remoo de um perfil associado a um usurio.
   *
   * @throws Exception .
   */
  public void testRemoveWithUsers() throws Exception {
    initializeUN(1);
    initializeRole(1);
    initializeUser(un[0], role[0], 0, 3);
    try {
      Role.deleteRole(role[0].getId());
      fail("Esperada AdministrationDeleteException");
    }
    catch (AdministrationDeleteException pe) {}
    assertEquals("0", role[0].getName());
    Role aRole = Role.getRole(role[0].getId());
    assertEquals("0", aRole.getName());
    Vector allRoles = Role.getAllRoles();
    assertEquals(1, allRoles.size());
    cleanUser(0, 3);
    cleanRole(1);
    cleanUN(1);
    assertNull(role);
    allRoles = Role.getAllRoles();
    assertEquals(0, allRoles.size());
  }
}
