/**
 * TestUN.java  $Author: cassino $ $Revision: 33587 $ - $Date: 2004/03/17
 * 20:22:57 $
 */
package server.providers;

import csbase.logic.*;

import util.*;

import java.util.Vector;

/**
 * A classe <code>TestUN_User</code> representa um caso de teste para os
 * relacionamentos entre as UNs e os Usurios.
 */
public class TestUN_User extends CSBaseAbstractTestCase {
  /**
   * Testa remoo de uma UN associada a um usurio.
   *
   * @throws Exception .
   */
  public void testRemoveWithUsers() throws Exception {
    initializeUN(1);
    initializeRole(1);
    initializeUser(un[0], role[0], 0, 3);
    try {
      UN.deleteUN(un[0].getId());
      fail("Esperada AdministrationDeleteException");
    }
    catch (AdministrationDeleteException pe) {}
    assertEquals("0", un[0].getName());
    UN aUN = UN.getUN(un[0].getId());
    assertEquals("0", aUN.getName());
    Vector allUNs = UN.getAllUNs();
    assertEquals(1, allUNs.size());
    cleanUser(0, 3);
    cleanRole(1);
    cleanUN(1);
    assertNull(un);
    allUNs = UN.getAllUNs();
    assertEquals(0, allUNs.size());
  }
}
