/**
 * TestRole_User.java
 * 
 * $Author: glaucio $
 * $Revision: 33584 $ - $Date: 2004-04-13 11:49:18 -0300 (Tue, 13 Apr 2004) $
 */

package server.providers;

import java.util.Vector;
import java.rmi.RemoteException;

import util.*;
import csbase.logic.*;

/**
 * A classe <code>TestRole_User</code> representa um caso de teste para os
 * relacionamentos entre os Perfis e os Usurios.
 */
public class TestRole_User extends CSBaseAbstractTestCase {
  
  /**
   * Testa remoo de um perfil associado a um usurio.
   */
  public void testRemoveWithUsers() throws Exception {
    
    initializeUN( 1 );
    initializeRole( 1 );

    initializeUser( un[0], role[0], 0 , 3 );
    
    try {
      Role.deleteRole( role[0].getId() );
      fail("Esperada RemoteException");
    } catch( RemoteException pe ) { }

    assertEquals( "0", role[0].getName() );
    Role aRole = Role.getRole( role[0].getId() );
    assertEquals( "0", aRole.getName() );
    Vector allRoles = Role.getAllRoles();
    assertEquals( 1, allRoles.size() );

    cleanUser(0,3);
    cleanRole( 1 );
    cleanUN( 1 );

    assertNull(role);
    allRoles = Role.getAllRoles();
    assertEquals( 0, allRoles.size() );
    
  }

  
}





