/**
 * TestLoginService.java $Author: cassino $ $Revision: 33587 $ - $Date:
 * 2003/11/24 10:05:38 $
 */
package server.services;

import csbase.logic.*;
import csbase.remote.*;

import util.*;

import java.rmi.RemoteException;
import java.util.*;

/**
 * A classe <code>TestMailService</code>
 */
public class TestMailService extends CSBaseAbstractTestCase {
  /**
   * Os seguintes testes foram realizados:  - testSendMail OK -
   * testSendMailToNull FAILED - testMailTo OK   - testMailToNull OK
   */
  private static String MAIL_PROP = "mailservice_test";
  private static ResourceBundle prop = ResourceBundle.getBundle(MAIL_PROP);
  private MailServiceInterface mailService;

  public void setUp() {
    mailService = RemoteLocator.mailService;
  }

  /**
   * Envia um e-mail a um destinatrio configurado nas propriedades.
   *
   * @throws RemoteException .
   */
  public void testSendMail() throws RemoteException {
    boolean result =
      mailService.sendMail(
        "teste", prop.getString("testmailaddress"), "Teste automatizado");
    assertTrue(result);
  }

  /**
   * Testa envio para endereo nulo ERRO: NULL POINTER public void
   * testSendMailToNull() throws RemoteException { boolean result =
   * mailService.sendMail("teste",  null, "Teste automatizado");
   * assertFalse(result); }
   *
   * @throws RemoteException .
   * @throws Exception .
   */
  /**
   * Envia um e-mail a um usurio criado com o e-mail configurado nas
   * propriedades.
   *
   * @throws RemoteException .
   * @throws Exception .
   */
  public void testMailTo() throws RemoteException, Exception {
    User user = createTestUser(prop.getString("testmailaddress"));
    boolean result =
      mailService.mailTo("teste", user.getId(), "Teste automatizado");
    assertTrue(result);
  }

  /**
   * Tenta enviar um e-mail passando nulo no lugar do id do usurio.
   *
   * @throws RemoteException .
   */
  public void testMailToNull() throws RemoteException {
    boolean result = mailService.mailTo("teste", null, "Teste automatizado");
    assertFalse(result);
  }
}
