/**
 * TestLoginService.java $Author: cassino $ $Revision: 33587 $ - $Date:
 * 2004/04/07 18:40:23 $
 */
package server.services;

import csbase.client.kernel.ClientException;
import csbase.client.language.LNG;
import csbase.logic.*;
import csbase.remote.RemoteLocator;
import csbase.server.services.projectservice.*;

import junit.framework.TestSuite;

import util.*;

import java.io.*;
import java.nio.*;
import java.rmi.RemoteException;
import java.util.*;

/**
 * A classe <code>TestCreateMultiUserProject</code>  responsvel  por criar um
 * projeto multi-usurio com n usurios.
 */
public class TestCreateMultiUserProject extends CSBaseTestCase {
  private static final String TEXT_TYPE = "TEXT";
  private static final String NOME_PROJETO = "projeto";
  private UN cenpes = null;
  private Role tecnico = null;
  private CommonClientProject projeto = null;
  private ClientProjectFile arq1 = null;
  private ClientProjectFile arq2 = null;
  private User[] users;
  private String usersNames;

  public void setUp() throws Exception {}

  public void tearDown() {}

  public String getClassName() {
    return "TESTCREATEMULTIUSERPROJECT";
  }

  public void cleanElements(Vector elements) {}

  public Vector getAllElements() {
    return null;
  }

  /**
   * Cria os usurios, o projeto e adiciona os usurios ao projeto.
   *
   * @throws Exception .
   */
  public void testInitial() throws Exception {
    this.usersNames = System.getProperty("userNames");
    System.out.println("Names: " + usersNames);
    Integer size = new Integer(System.getProperty("userSize"));
    System.out.println("Size: " + size);
    this.users = new User[size.intValue()];
    cenpes = createTestUN("Cenpes");
    tecnico = createTestRole("Tcnico");
    for (int i = 0; i < users.length; i++) {
      String name = usersNames + i;
      System.out.println("UserName: " + name);
      users[i] = createTestUser(name, cenpes, tecnico);
    }
    projeto = createTestProject(NOME_PROJETO, users[0]);
    ProjectFile root = projeto.getTree();
    projeto.createAndWaitForFile(root, "arq1", TEXT_TYPE, users[0].getId());
    arq1 = (ClientProjectFile)root.getChild("arq1");
    projeto.createAndWaitForFile(root, "arq2", TEXT_TYPE, users[1].getId());
    arq2 = (ClientProjectFile)root.getChild("arq2");
    /*Adiciona usuarios ao projeto*/
    Object[] ids = new Object[users.length - 1];
    for (int i = 1; i < users.length; i++) {
      ids[i - 1] = users[i].getId();
    }
    projeto.updateUsers(ids);
    assertNull(null);
  }

  public TestCreateMultiUserProject(String name) throws ClientException {
    super(name);
  }

  public TestCreateMultiUserProject() throws ClientException {
    super();
  }
}
