/**
 * TesteMultUserClient.java $Author: cassino $ $Revision: 33587 $ - $Date:
 * 2004/04/07 18:40:45 $
 */
package server.services;

import csbase.client.kernel.ClientException;
import csbase.client.language.LNG;
import csbase.client.remote.ProjectObserver;
import csbase.logic.*;
import csbase.remote.RemoteLocator;
import csbase.server.services.projectservice.*;

import junit.framework.TestSuite;

import util.*;

import java.io.*;
import java.nio.*;
import java.rmi.RemoteException;
import java.util.*;

/**
 * A classe <code>TestMultiUserClient</code> simula um usurio abrindo um
 * projeto multi-usurio e realizando vrias operaes de abrir, ler e
 * escrever em arquivos.
 */
public class TestMultiUserClient extends CSBaseTestCase {
  private static final String TEXT_TYPE = "TEXT";
  private static final String NOME_PROJETO = "projeto";
  private String name;
  private int pos;
  private String userId;

  public void setUp() throws Exception {}

  public void tearDown() {}

  public String getClassName() {
    return "TESTMULTIUSERCLIENT";
  }

  public void cleanElements(Vector elements) {}

  public Vector getAllElements() {
    return null;
  }

  /**
   *
   */
  public void testInitial() throws Exception {
    /*Obtem as propriedades*/
    this.name = System.getProperty("userNames");
    this.pos = (new Integer(System.getProperty("userSize"))).intValue();
    this.userId = name + pos;
    /* Abre o projeto e cria arquivo */
    String owner = name + 0;
    CommonClientProject proj =
      CommonClientProject.openProject(owner, NOME_PROJETO);
    proj.installObserver(new ProjectObserver(proj));
    ProjectFile root = proj.getTree();
    /*Cria x arquivos com o nome do usurio e escreve neles*/
    for (int i = 0; i < 50; i++) {
      String fileName = name + "_" + pos + "_" + i;
      System.out.println("FileName: " + fileName);
      proj.createAndWaitForFile(root, fileName, TEXT_TYPE, userId);
      ClientProjectFile arq = (ClientProjectFile)root.getChild(fileName);
      arq.open();
      String conteudo = fileName;
      byte[] array = conteudo.getBytes();
      ByteBuffer buffer = ByteBuffer.wrap(array);
      for (int j = 0; j < buffer.capacity(); j += arq.write(buffer, j)) {
        try {
          Thread.sleep(100);
        }
        catch (InterruptedException e) {}
      }
      arq.truncate(conteudo.length());
      arq.close();
    }
    /* Abre um arquivo existente e escreve nele */
    ClientProjectFile arq1 = (ClientProjectFile)root.getChild("arq1");
    arq1.open();
    StringBuffer texto = new StringBuffer();
    for (int i = 0; i < 100; i++) {
      System.out.println("Escrevendo no arq1");
      texto.append(userId + " teste \n");
    }
    String text = texto.toString();
    int size = text.length();
    byte[] array = text.getBytes();
    ByteBuffer buffer = ByteBuffer.wrap(array);
    for (int i = 0; i < buffer.capacity(); i += arq1.write(buffer, i)) {
      try {
        Thread.sleep(100);
      }
      catch (InterruptedException e) {}
    }
    arq1.truncate(size);
    arq1.close();
    /*Tenta criar 10 vezes um arquivo com um nome fixo*/
    for (int i = 0; i < 10; i++) {
      try {
        proj.createAndWaitForFile(root, "FIXO", TEXT_TYPE, userId);
      }
      catch (Exception e) {
        System.out.println(e.getMessage());
      }
    }
    assertNull(null);
  }

  public TestMultiUserClient(String name) throws ClientException {
    super(name);
  }

  public TestMultiUserClient() throws ClientException {
    super();
  }
}
